<%@ Language=JavaScript %>
<!---
//*****************************************************************************
//*
//* Copyright (c) ComponentOne, LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/utils.inc" -->

<html>

  <head>
    <title>ComponentOne WebChart 2D - Floating Stacked Bars</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    DemoPageHeader();
    DemoTitle2D("Floating Stacked Bars Example");

    function gen_select_entry(selector, value, label)
    {
      Response.Write("<OPTION value=\"" + value + "\"");
      if(Request.Form(selector) == value)
        Response.Write(" selected");
      Response.Write("> " + label + "\n");
    }

    function gen_selector(selector)
    {
      Response.Write("<select name=\"" + selector + "\" size=1>\n");
      gen_select_entry( selector, "SHOW", "Show");
      gen_select_entry( selector, "HIDE", "Hide");
      gen_select_entry( selector, "EXCLUDE", "Exclude");
      Response.Write("</select>");
    }

    function selector_to_enum(selector)
    {
      if(Request.Form(selector) == "HIDE")
        return oc2dDisplayHide;
      else if(Request.Form(selector) == "EXCLUDE")
        return oc2dDisplayExclude;
      else
        return oc2dDisplayShow;
    }

    var CurrentReverseLegend;
    CurrentReverseLegend = (Request.Form("ReverseLegend") == "ON");

    var CurrentHundredPercent;
    CurrentHundredPercent = (Request.Form("HundredPercent") == "ON");
  %>

  <p align=center>
    Please indicate whether to show, hide or exclude each series.<br>
  </p>

  <table border=0 align=center cellpadding=1 cellspacing=1 style=width:50% width=50% >
    <tr>
      <td align=center>Series 1</td>
      <td align=center>Series 2</td>
      <td align=center>Series 3</td>
      <td align=center>Series 4</td>
    </tr>
  </table>

  <form action="FloatStack.asp" method="post" id="form1" name="form1">
    <table border=0 align=center cellSpacing=1 style=width:50% width=50% >
      <tr>
        <td align=center><% gen_selector("Series1") %></td>
        <td align=center><% gen_selector("Series2") %></td>
        <td align=center><% gen_selector("Series3") %></td>
        <td align=center><% gen_selector("Series4") %></td>
      </tr>
    </table>
    <br><br>
    <table border=0 align=center width=50% >
      <tr>
        <td>
          <input id="ReverseLegend" name="ReverseLegend" type="checkbox"
            <% DemoCheckWriter(CurrentReverseLegend) %> value="ON">
          Reverse the legend?
        </td>
        <td>
          <input id="HundredPercent" name="HundredPercent" type="checkbox" 
            <% DemoCheckWriter(CurrentHundredPercent) %> value="ON">
          100 percent? 
        </td>
      </tr>
    </table>
    <br><br>
    <table border=0 align=center width=90% >
      <tr align=center>
        <td>
          Please click <input type="submit" name="B1" value="Submit"> to see
          the changes reflected in the chart below:
        </td>
      </tr>
    </table>
  </form>

  <!--METADATA TYPE="DesignerControl" startspan
    <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" id=Chart2D1 height=401 width=601
      style="HEIGHT: 401px; LEFT: 0px; TOP: 0px; WIDTH: 601px">
      <PARAM NAME="PersistenceVersion" VALUE="1">
      <PARAM NAME="Language" VALUE="2">
      <PARAM NAME="ByteCount" VALUE="1581">
      <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E32441E3E00007229000000000000020000000400000000000000FEFFFFFF0200FF00000001000000FFFFFFFFFF000000">
      <PARAM NAME="Part1" VALUE="02000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
      <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
      <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF000000070000000000000000000000010100040000000131013201330134000000006E00000100A0">
      <PARAM NAME="Part4" VALUE="C8EB85F3CCE17F0400000005000000000000000000F03F0000000000003440000000000000204000000000000024400000000000003040000000000000004000">
      <PARAM NAME="Part5" VALUE="00000000003640000000000000284000000000000030400000000000003340000000000000084000000000000033400000000000002440000000000000314000">
      <PARAM NAME="Part6" VALUE="00000000002E400000000000001040000000000000384000000000000028400000000000002E4000000000000036400000000000001440000000000000394000">
      <PARAM NAME="Part7" VALUE="00000000002E40000000000000374000000000000032400100010001000100000000000000000004000100000000000000000000000000000000000000000000">
      <PARAM NAME="Part8" VALUE="000000000000000000000100A0C8EB85F3CCE17F0000000000000000000000000200020000000000000000000000000000000000030004000000355573652074">
      <PARAM NAME="Part9" VALUE="686520436865636B20426F7865732041626F766520746F2048696465206F72204578636C756465206120536572696573FFFFE000FFFFFFFF00010000003B0000">
      <PARAM NAME="Part10" VALUE="000111000000010005417269616CC0D4010000000000000000009001000001030000000200000000FFFFFFFFFFFFFFFF00010000000501000001890100000100">
      <PARAM NAME="Part11" VALUE="05417269616CC0D40100000000000000000090010000010300050003000000FFFFFFFFFFFFFFFF000100000007020000018D000000010005417269616CC0D401">
      <PARAM NAME="Part12" VALUE="0000000000000000009001000006536572696573010100010000090004000000ADD8E6000000000000010000000000000003000500000098FB9800FFFFFFFF00">
      <PARAM NAME="Part13" VALUE="0100000019000000013D00000001D90100000142010000010000000032000000054F74686572FFFFFFFFFFFF0000020000000000000000000101000300010000">
      <PARAM NAME="Part14" VALUE="00000000000000010000000000000000E060400A0000000A0000000A0000000100FFFFFFFFFFFFFFFF0001000000100000000124000000012800000001090000">
      <PARAM NAME="Part15" VALUE="0001000300000000000000000000F03F01000000000000144001000000000000E03F01000000000000164001000000000000F03F01000000000000E03F010000">
      <PARAM NAME="Part16" VALUE="000001000000000100000000000000E03F010000000000000000000400000000000100000001020000000000010000000200010825483A254D3A255301010000">
      <PARAM NAME="Part17" VALUE="00000040F8D8400005417269616CC0D4010000000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000">
      <PARAM NAME="Part18" VALUE="0000000001000000000040544001000000000000000001000000000000594001000000000000344001000000000000244001FFFFFFFF01000000000100000000">
      <PARAM NAME="Part19" VALUE="0000000000010000000000000000000400000000000100000001020000000000010000000200010000000000805640010005417269616CC0D401000000000000">
      <PARAM NAME="Part20" VALUE="000000900100000100000100000000000000000000000100000000000000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE1">
      <PARAM NAME="Part21" VALUE="7F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F010000000001000000000100020000000000010000000200010000000000805640010005417269616CC0D40100">
      <PARAM NAME="Part22" VALUE="00000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000020000000500000000000100000001000000">
      <PARAM NAME="Part23" VALUE="01000000010000000000000000000000000000000000000001000000000101000500000000000100000001000000010000000100000000000000000000000000">
      <PARAM NAME="Part24" VALUE="000000000000010000000001020001010000000001000000000000001440000000000000344000010100010000">
    </OBJECT>
  -->
  <!--METADATA TYPE="DesignerControl" endspan-->

  <%
    var Chart2D1;
    Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent");

    function Chart2D1_Load()
    {
      with(Chart2D1)
      {
        Width = 600;
        Height = 400;
        IsBatched = true;
      
        with(ChartArea)
        {
          DemoInitFont(Axes("X").Font,12,false);
          DemoInitFont(Axes("Y").Font,12,false);
          DemoInitFont(Axes("Y2").Font,12,false);
          
          with(Border)
          {
            Type = oc2dBorderShadow;
            Width = 5;
          }

          Interior.BackgroundColor = 10025880;
          Pie.OtherLabel.Text = "Other";

          with(View3D)
          {
            Depth = 10;
            Elevation = 10;
            Rotation = 10;
          }
        }

        with(Border)
        {
          Type = oc2dBorderBevel;
          Width = 4;
        }

        Interior.BackgroundColor = 15128749;

        with(Header)
        {
          with(Border)
          {
            Type = oc2dBorderShadow;
            Width = 4;
          }
          DemoInitFont(Font,12,false);

          Interior.BackgroundColor = 14745599;
        
          Text.Text = "Use the Check Boxes Above to Hide or Exclude a Series";
        }

        DemoInitFont(Footer.Font,12,false);
        
        with(Legend)
        {
          with(Border)
          {
            Type = oc2dBorderEtchedIn;
            Width = 3;
          }
          DemoInitFont(Font,12,false);
          Text.Text = "Series";
        }

        with(ChartGroups(1))
        {
          ChartType = oc2dTypeStackingBar;
          with(SeriesLabels)
          {
            Add("1");
            Add("2");
            Add("3");
            Add("4");
          }
        }

        with(ChartGroups(2))
        {
          ChartType = oc2dTypeBar;
          Data.IsSaved = false;
        }
        
        IsBatched = false;
      }
    } 

    Chart2D1_Load();

    with(Chart2D1)
    {
      Legend.IsReversed = CurrentReverseLegend;
      ChartArea.Axes("Y").Is100Percent = CurrentHundredPercent;
  
      // Set the display mode for each series. 
      with(ChartGroups(1).Data)
      {
        SeriesDisplay(1) = selector_to_enum("Series1");
        SeriesDisplay(2) = selector_to_enum("Series2");
        SeriesDisplay(3) = selector_to_enum("Series3");
        SeriesDisplay(4) = selector_to_enum("Series4");
      }
    }

    DemoSeparator();
  %>

  <p align=center>
    <%
      var dispChart = Session("DispChart");
      if(dispChart == "Jpeg")
        OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png")
        OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png-BinaryWrite")
        OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1");
      else if(dispChart == "Jpeg-BinaryWrite")
        OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1");
      else
        OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1");
    %>
  </p>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        Interaction with this demo is performed using the Show/Hide/Exclude
        list boxes and the two check boxes. Specifically:
        <ul>
          <li>The &quot;Reverse the legend&quot; option toggles the displayed order of the Legend. </li>
          <li>The &quot;100 percent&quot; option toggles the axis property that treats values within a
            series as percentages of a 100% total. </li>
          <li>The Hide list box entries are used to hide a series -- the series is not drawn, but the
            chart still leaves room for it. </li>
          <li>The Exclude list box entries are used to exclude a series -- the series is not drawn and
            the chart does not leave room for it (that is, the series is now treated as nonexistent). </font></li>
        </ul>
      </td>
    </tr>
  </table>

  <%
    DemoSeparator();
    DemoCopyrightAndSource();
    Chart2D1 = 0;
  %>

  </body>
</html>
