<%@ Language=JavaScript %>
<!---
//*****************************************************************************
//*
//* Copyright (c) ComponentOne, LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/utils.inc" -->

<html>

  <head>
    <title>ComponentOne WebChart 2D - Box-and-Whisker Example</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    var NumberOfPoints;
    if(Request.Form("text1").Count == 0)
      NumberOfPoints = 5;
    else
      NumberOfPoints = Request.Form("text1");

    //Set up the page headers and titles
    DemoPageHeader();                         // utils.inc
    DemoTitle2D("Box-and-Whisker Example");   // utils.inc
  %>

  <form action="boxwhisk.asp" method="post" id="form1" name="form1">
    <table border=0 align=center width=80% cellpadding=5>
      <tr align=center>
        <td>
          Number of data points (1 to 15):
          <input id=text1 name="text1" value="<%= NumberOfPoints %>" size=2>
        </td>
      </tr>
      <tr align=center>
        <td>
          <input type="submit" name="B1" value="Re-generate the chart" language="JavaScript" onclick=B1_onclick()>
          <script language="JavaScript">
            //Client side script to clamp values within range
            function B1_onclick()
            {
              if(document.form1.text1.value > 15)
                document.form1.text1.value = "15";
              else if(document.form1.text1.value < 1)
                document.form1.text1.value = "1";
            }
          </script>
        </td>
      </tr>
    </table>
  </form>

  <!--METADATA TYPE="DesignerControl" startspan
    <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" height=379 width=477
      id=Chart2D1 style="HEIGHT: 379px; LEFT: 0px; TOP: 0px; WIDTH: 477px">
      <PARAM NAME="PersistenceVersion" VALUE="1">
      <PARAM NAME="Language" VALUE="2">
      <PARAM NAME="TagRoutine" VALUE="">
      <PARAM NAME="ByteCount" VALUE="2337">
      <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E32444D3100002C27000000000000020000000400000000000000FEFFFFFF0200A020F00002000000FFFFFFFFA020F000">
      <PARAM NAME="Part1" VALUE="01000400FF00FF000C000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
      <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
      <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF00000007000000000000000000000001010000000000000000000100000100A0C8EB85F3CCE17F04">
      <PARAM NAME="Part4" VALUE="00000005000000000000000000F03F0000000908A9584000000000B495E03F0000000EE71E544000000010A4CC30400000000000000040000000FD323A584000">
      <PARAM NAME="Part5" VALUE="000098BBBF3940000000A5501756400000009E554B4B4000000000000008400000008716545840000000804FE0E83F0000002E83C15440000000585043244000">
      <PARAM NAME="Part6" VALUE="00000000001040000000BEAB64584000000010FAC724400000001049FE5640000000AE58C045400000000000001440000000D272985840000000A0908B114000">
      <PARAM NAME="Part7" VALUE="000021FDE25240000000DAC9D146400100010001000100000000000000000008000100000000000000000000000000000000000400000000000000FEFFFFFF02">
      <PARAM NAME="Part8" VALUE="00A020F00002000000FFFFFFFFA020F00001000200FFA5000007000000000000000000000001010001000000FEFFFFFF0200C715850001000000FFFFFFFFC715">
      <PARAM NAME="Part9" VALUE="8500020005006B8E230007000000000000000000000001010002000000FEFFFFFF0200DDA0DD0001000000FFFFFFFFDDA0DD0002000600FF0000000700000000">
      <PARAM NAME="Part10" VALUE="0000000000000001010003000000FEFFFFFF02007FFFD40001000000FFFFFFFF7FFFD400020003009ACD32000700000000000000000000000101000000000000">
      <PARAM NAME="Part11" VALUE="0000000100000100A0C8EB85F3CCE17F040000000F000000000000000000F03F00000000B495E03F00000000B495E03F00000000B495E03F00000000B495E03F">
      <PARAM NAME="Part12" VALUE="000000000000F03F0000000908A958400000000908A958400000000908A958400000000908A95840000000000000F03F00000018A037454000000018A0374540">
      <PARAM NAME="Part13" VALUE="00000018A037454000000018A0374540000000000000004000000098BBBF394000000098BBBF394000000098BBBF394000000098BBBF39400000000000000040">
      <PARAM NAME="Part14" VALUE="000000FD323A5840000000FD323A5840000000FD323A5840000000FD323A58400000000000000040000000782E965340000000782E965340000000782E965340">
      <PARAM NAME="Part15" VALUE="000000782E9653400000000000000840000000804FE0E83F000000804FE0E83F000000804FE0E83F000000804FE0E83F00000000000008400000008716545840">
      <PARAM NAME="Part16" VALUE="000000871654584000000087165458400000008716545840000000000000084000000000F659444000000000F659444000000000F659444000000000F6594440">
      <PARAM NAME="Part17" VALUE="000000000000104000000010FAC7244000000010FAC7244000000010FAC7244000000010FAC724400000000000001040000000BEAB645840000000BEAB645840">
      <PARAM NAME="Part18" VALUE="000000BEAB645840000000BEAB6458400000000000001040000000A97E1D5040000000A97E1D5040000000A97E1D5040000000A97E1D50400000000000001440">
      <PARAM NAME="Part19" VALUE="000000A0908B1140000000A0908B1140000000A0908B1140000000A0908B11400000000000001440000000D272985840000000D272985840000000D272985840">
      <PARAM NAME="Part20" VALUE="000000D2729858400000000000001440000000268C294F40000000268C294F40000000268C294F40000000268C294F4001000100010001000000000000000000">
      <PARAM NAME="Part21" VALUE="070002000000000000000000000000000000000001000400000014426F782D616E642D576869736B657220506C6F74FFFFFFFFFFFFFFFF00010000008B000000">
      <PARAM NAME="Part22" VALUE="0116000000010005417269616CA42C020000000000000000009001000001030000000200000000FFFFFFFFFFFFFFFF0001000000EE000000016F010000010005">
      <PARAM NAME="Part23" VALUE="417269616CC0D40100000000000000000090010000010300000002000000FFFFFFFFFFFFFFFF0001000000CA01000001B7000000010005417269616CC0D40100">
      <PARAM NAME="Part24" VALUE="00000000000000009001000000010100010000070006000000C2C2C20000000000000100000000000000020004000000F5DEB300FFFFFFFF0001000000190000">
      <PARAM NAME="Part25" VALUE="00014900000001AB010000011F01000001000000003200000000FFFFFFFFFFFF0000020000000000000000000101000300010000000000000000000100000000">
      <PARAM NAME="Part26" VALUE="00000000E060400000000000000000000000000100FFEBCD00FFFFFFFF0001000000110000000125000000011700000001180000000101030000000000000000">
      <PARAM NAME="Part27" VALUE="0000F03F01000000000000144001000000000000E03F01000000000000164001000000000000F03F01000000000000E03F010000000000000000000100000000">
      <PARAM NAME="Part28" VALUE="000000E03F010000000000000000000400000000000100000001020000000000010000000200010825483A254D3A25530101000000000040F8D8400005417269">
      <PARAM NAME="Part29" VALUE="616CC0D4010000000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000B495E03F010000000908A958">
      <PARAM NAME="Part30" VALUE="4001000000000000000001000000000000594001000000000000244001000000000000144001FFFFFFFF01000000000100000000000000000001000000000000">
      <PARAM NAME="Part31" VALUE="2440010400000000000100000001020000000000010000000200010000000000805640010005417269616CC0D401000000000000000000900100000100000100">
      <PARAM NAME="Part32" VALUE="00000000000000000000010000000000000000000000B495E03F010000000908A958400100000000000000000100000000000059400100000000000024400100">
      <PARAM NAME="Part33" VALUE="0000000000144001FFFFFFFF01000000000100020000000000010000000200010000000000805640010005417269616CC0D40100000000000000000090010000">
      <PARAM NAME="Part34" VALUE="00000001000000000000000000000001000000000000000000000000000000000000020000000500000000000100000001000000010000000100000000000000">
      <PARAM NAME="Part35" VALUE="00000000000000000000000001000000000101000500000000000100000001000000010000000100000000000000000000000000000000000000010000000001">
      <PARAM NAME="Part36" VALUE="020001010000000001000000000000001440000000000000344001010100010001">
    </OBJECT>
  -->
  
  <%
    var Chart2D1;
    Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent");
  
    function Chart2D1_Load()
    {
      with(Chart2D1)
      {
        Width = 477;
        Height = 379;
  
        with(ChartArea)
        {
          IsHorizontal = true;
          Axes("X").Precision.Value = 0;
          Axes("Y").MajorGrid.Spacing.IsDefault = true;
          Axes("Y2").IsShowing = false;
  
          with(Border)
          {
            Type = oc2dBorder3DIn;
            Width = 4;
          }
  
          Interior.BackgroundColor = 11788021;
  
          with(PlotArea)
          {
            IsBoxed = true;
            Interior.BackgroundColor = 13495295;
          }
        }
  
        with(Border)
        {
          Type = oc2dBorderFrameIn;
          Width = 6;
        }
  
        Interior.BackgroundColor = 12763842;
  
        with(Header)
        {
          with(Border)
          {
            Type = oc2dBorder3DOut;
            Width = 4;
          }
          Text.Text = "Box-and-Whisker Plot";
        }
  
        with(ChartGroups(1))
        {
          ChartType = oc2dTypeCandle;
          with(Data)
          {
            X(1, 1) = 1;
            X(1, 2) = 2;
            X(1, 3) = 3;
            X(1, 4) = 4;
            X(1, 5) = 5;
            Y(1, 1) = 98.6411154270172;
            Y(1, 2) = 96.909362077713;
            Y(1, 3) = 97.3138749599457;
            Y(1, 4) = 97.5729823112488;
            Y(1, 5) = 98.3820080757141;
            Y(2, 1) = 0.518274307250977;
            Y(2, 2) = 25.7489562034607;
            Y(2, 3) = 0.777381658554077;
            Y(2, 4) = 10.39057970047;
            Y(2, 5) = 4.38629388809204;
            Y(3, 1) = 80.4828524589539;
            Y(3, 2) = 88.3642971515656;
            Y(3, 3) = 83.0236315727234;
            Y(3, 4) = 91.9732093811035;
            Y(3, 5) = 75.5466997623444;
            Y(4, 1) = 16.7993783950806;
            Y(4, 2) = 54.5885503292084;
            Y(4, 3) = 10.1314723491669;
            Y(4, 4) = 43.5027062892914;
            Y(4, 5) = 45.6389725208282;
          }
  
          with(Styles(1))
          {
            with(Line)
            {
              Color = 15736992;
              Width = 2;
            }
            with(Fill)
            {
              Pattern = oc2dFillNone;
              Interior.ForegroundColor = 15736992;
            }              
            Symbol.Size = 12;
          }
        }
  
        with(ChartGroups(2))
        {
          ChartType = oc2dTypeHiLoOpenClose;
  
          with(Data)
          {
            NumSeries = 4;
            NumPoints(1) = 15;
            NumPoints(2) = 15;
            NumPoints(3) = 15;
            NumPoints(4) = 15;
            X(1, 1) = 1;
            X(1, 2) = 1;
            X(1, 3) = 1;
            X(1, 4) = 2;
            X(1, 5) = 2;
            X(1, 6) = 2;
            X(1, 7) = 3;
            X(1, 8) = 3;
            X(1, 9) = 3;
            X(1, 10) = 4;
            X(1, 11) = 4;
            X(1, 12) = 4;
            X(1, 13) = 5;
            X(1, 14) = 5;
            X(1, 15) = 5;
            Y(1, 1) = 0.518274307250977;
            Y(1, 2) = 98.6411154270172;
            Y(1, 3) = 42.4345731735229;
            Y(1, 4) = 25.7489562034607;
            Y(1, 5) = 96.909362077713;
            Y(1, 6) = 78.346586227417;
            Y(1, 7) = 0.777381658554077;
            Y(1, 8) = 97.3138749599457;
            Y(1, 9) = 40.7028198242188;
            Y(1, 10) = 10.39057970047;
            Y(1, 11) = 97.5729823112488;
            Y(1, 12) = 64.4608557224274;
            Y(1, 13) = 4.38629388809204;
            Y(1, 14) = 98.3820080757141;
            Y(1, 15) = 62.3245894908905;
            Y(2, 1) = 0.518274307250977;
            Y(2, 2) = 98.6411154270172;
            Y(2, 3) = 42.4345731735229;
            Y(2, 4) = 25.7489562034607;
            Y(2, 5) = 96.909362077713;
            Y(2, 6) = 78.346586227417;
            Y(2, 7) = 0.777381658554077;
            Y(2, 8) = 97.3138749599457;
            Y(2, 9) = 40.7028198242188;
            Y(2, 10) = 10.39057970047;
            Y(2, 11) = 97.5729823112488;
            Y(2, 12) = 64.4608557224274;
            Y(2, 13) = 4.38629388809204;
            Y(2, 14) = 98.3820080757141;
            Y(2, 15) = 62.3245894908905;
            Y(3, 1) = 0.518274307250977;
            Y(3, 2) = 98.6411154270172;
            Y(3, 3) = 42.4345731735229;
            Y(3, 4) = 25.7489562034607;
            Y(3, 5) = 96.909362077713;
            Y(3, 6) = 78.346586227417;
            Y(3, 7) = 0.777381658554077;
            Y(3, 8) = 97.3138749599457;
            Y(3, 9) = 40.7028198242188;
            Y(3, 10) = 10.39057970047;
            Y(3, 11) = 97.5729823112488;
            Y(3, 12) = 64.4608557224274;
            Y(3, 13) = 4.38629388809204;
            Y(3, 14) = 98.3820080757141;
            Y(3, 15) = 62.3245894908905;
            Y(4, 1) = 0.518274307250977;
            Y(4, 2) = 98.6411154270172;
            Y(4, 3) = 42.4345731735229;
            Y(4, 4) = 25.7489562034607;
            Y(4, 5) = 96.909362077713;
            Y(4, 6) = 78.346586227417;
            Y(4, 7) = 0.777381658554077;
            Y(4, 8) = 97.3138749599457;
            Y(4, 9) = 40.7028198242188;
            Y(4, 10) = 10.39057970047;
            Y(4, 11) = 97.5729823112488;
            Y(4, 12) = 64.4608557224274;
            Y(4, 13) = 4.38629388809204;
            Y(4, 14) = 98.3820080757141;
            Y(4, 15) = 62.3245894908905;
          }
  
          with(Styles(1))
          {
            with(Line)
            {
              Color = 15736992;
              Width = 2;
            }
            with(Fill)
            {
              Pattern = oc2dFillNone;
              Interior.ForegroundColor = 15736992;
            }
          }
        }
      }
    }

    Chart2D1_Load();
  
  %>
  
  <!--METADATA TYPE="DesignerControl" endspan-->
  
  <%
    var DataSets;
    var ChartData;

    function FindTheFiveDataValues()
    {
      //Find the Low, High, Median and Upper/Lower Quartiles of the data.
      var xi;
      for(xi = 1; xi <= NumberOfPoints; xi++)
      {
        ChartData[xi][1] = DataSets[xi][1];           //Lowest Value in the set of Data
        ChartData[xi][2] = DataSets[xi][15];          //Highest Value in the set of Data
        
        //The median is the value exactly in the middle of an ordered set of numbers.
        //If you're finding the median in an ordered set with an even number of values,
        // you must take the average of the two middle numbers. For example:
        //      3, 5, 7, and 10. Add the two middle numbers. 5 + 7 = 12.
        //      Divide 12 by 2 to get the average. 12 / 2 = 6.
        //      Therefore 6 is the median for the ordered set of 3, 5, 7, and 10.
        ChartData[xi][3] = DataSets[xi][8];           //Median Value (middle number of the set)
        
        //Next, we consider only the values to the left of the median. We now find the
        // median of this set of numbers. This number represents is the lower quartile.
        ChartData[xi][4] = DataSets[xi][4];           //Lower Quartile
        
        //Next, we consider only the values to the right of the median. We now find the
        // median of this set of numbers. This number represents is the lower quartile.
        ChartData[xi][5] = DataSets[xi][12];           //Upper Quartile
      }
    }

    function GenerateSomeData()
    {
      //Generate some random data to plot.

      var xi;
      var yi;
      var zi;

      //To save time later, setup all the x values in Chart Group 2 ahead of time
      // so that the x values cycle from 1 to 3 for each actual data point
      yi = 1;
      xi = 1;

      with(Chart2D1.ChartGroups(2).Data)
      {
        IsBatched = true;
        while( xi <= NumberOfPoints * 3)
        {
          for(zi = 1; zi <= 3; zi++)
          {
            x(1, xi) = yi;
            xi++;
          }
          yi++;
        }
        IsBatched = false;
      }

      DataSets = new Array(NumberOfPoints);
      ChartData = new Array(NumberOfPoints);

      //Create 15 random pieces of data for each point
      for(xi = 1; xi <= NumberOfPoints; xi++)
      {
        DataSets[xi] = new Array(15);
        ChartData[xi] = new Array(5);

        for(yi = 1; yi <= 15; yi++)
          DataSets[xi][yi] = (100 * Math.random());
      }
    }

    function LoadTheChartWithData()
    {
      //Actually put the data into the chart to create the Box-and-Whisker plot.

      var xi;
      var yi;
      var zi;

      with(Chart2D1.ChartGroups(1).Data)
      {
        IsBatched = true;
        for(xi = 1; xi <= NumberOfPoints; xi++)
        {
          y(1, xi) = ChartData[xi][2];          //Highest Value
          y(2, xi) = ChartData[xi][1];          //Lowest Value
          y(3, xi) = ChartData[xi][5];          //Upper Quartile
          y(4, xi) = ChartData[xi][4];          //Lower Quartile
        }
        IsBatched = false;
      }

      xi = 1;
      yi = 1;
      with(Chart2D1.ChartGroups(2).Data)
      {
        IsBatched = true;
        while(xi <= NumberOfPoints * 3)
        {
          //Add the error bars to the highest value, lowest value and the median
          for(zi = 1; zi <= 3; zi++)
          {
            y(1, xi) = ChartData[yi][zi];
            y(2, xi) = ChartData[yi][zi];
            y(3, xi) = ChartData[yi][zi];
            y(4, xi) = ChartData[yi][zi];
            xi++;
          }
          yi++;
        }
        IsBatched = false;
      }
    }

    function SortTheDataArrays()
    {
      // Use an Optimized Bubble Sort to sort the data arrays so
      // we can get the median and the quartiles of the data.

      var Done ;
      var HoldValue ;
      var xi ;
      var yi ;
      var MaxY ;

      Done = false;
      for(xi = 1; xi <= NumberOfPoints; xi++)
      {
        do
        {
          Done = true;
          MaxY = 14;
          for(yi = 1; yi <= MaxY; yi++)
          {
            if(DataSets[xi][yi] > DataSets[xi][yi + 1] )
            {
              HoldValue = DataSets[xi][yi];
              DataSets[xi][yi] = DataSets[xi][yi + 1];
              DataSets[xi][yi + 1] = HoldValue;
              Done = false;
            }
          }
          MaxY--;
        } while(!Done);
      }
    }

    //Batch the updates to the Chart so all the changes occur at once
    with(Chart2D1)
    {
      IsBatched = true;

      //Get the number of points to draw
      //Reset the number of points for both Data Groups
      ChartGroups(1).Data.NumPoints(1) = NumberOfPoints;
      ChartGroups(2).Data.NumPoints(1) = NumberOfPoints * 3;

      GenerateSomeData();
      SortTheDataArrays();
      FindTheFiveDataValues();
      LoadTheChartWithData();

      //Resume normal updating of the Chart
      IsBatched = false;
    }

    DemoSeparator();

  %>

  <p align="center">
    <%
      var dispChart = Session("DispChart");
      if(dispChart == "Jpeg")
        OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png")
        OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png-BinaryWrite")
        OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1");
      else if(dispChart == "Jpeg-BinaryWrite")
        OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1");
      else
        OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1");
    %>
  </p>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        This example employs both ChartGroups to produce an Box-and-Whisker
        Chart. A Candle Chart and a HiLoOpenClose Chart are combined.<br><br>
        The axis for the second ChartGroup is hidden because the actual data
        values of ChartGroup 2 are irrelevant in this example.
      </td>
    </tr>
  </table>
  
  <%
    DemoSeparator();
    DemoCopyrightAndSource();

    Chart2D1 = 0;
  %>
  </body>
</html>
