<%@ Language=JavaScript %>
<!---
//*****************************************************************************
//*
//* Copyright (c) ComponentOne, LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/utils.inc" -->

<html>
  <%
    function gen_select_entry(selector, value, label)
    {
      Response.Write("<OPTION value=\"" + value + "\"");
      if(Request.Form(selector) == value)
      {
        Response.Write("selected");
      }
      Response.Write("> " + label + "\n");
    }

    function gen_selector(selector)
    {
      Response.Write("<select name=\"" + selector + "\" size=1>\n");
      gen_select_entry( selector, "HILO", "High-Low");
      gen_select_entry( selector, "HLOC", "High-Low-Open-Close");
      gen_select_entry( selector, "CANDLE", "Candle");
      gen_select_entry( selector, "COMCAN", "Complex Candle");
      Response.Write("</select>");
    }

    var CurrentTickLength;
    if(Request.Form("TickLength").Count == 0)
      CurrentTickLength = 7;
    else
      CurrentTickLength = Request.Form("TickLength");

    var CurrentCandleWidth;
    if(Request.Form("CandleWidth").Count == 0)
      CurrentCandleWidth = 7;
    else
      CurrentCandleWidth = Request.Form("CandleWidth");

    var CurrentRisingWidth;
    if(Request.Form("RisingWidth").Count == 0)
      CurrentRisingWidth = 20;
    else
      CurrentRisingWidth = Request.Form("RisingWidth");

    var CurrentFallingWidth;
    if(Request.Form("FallingWidth").Count == 0)
      CurrentFallingWidth = 10;
    else
      CurrentFallingWidth = Request.Form("FallingWidth");

    var CurrentShowOpenTick;
    if(Request.Form("ShowOpenTick") == "on")
      CurrentShowOpenTick = true;
    else
      CurrentShowOpenTick = false;

    var CurrentShowCloseTick;
    if(Request.Form("ShowCloseTick") == "on")
      CurrentShowCloseTick = true;
    else
      CurrentShowCloseTick = false;
  %>

  <head>
    <title>ComponentOne WebChart 2D - High-Low-Open-Close and Candle Charts</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    //Set up the page headers and titles
    DemoPageHeader();                     // utils.inc
    DemoTitle2D("High-Low-Open-Close and Candle Charts Example"); // utils.inc
  %>

  <form action="hlcandle.asp" method="post">
    <p align=center>
      Chart Type: <%gen_selector("ChartType")%>
    </p>

    <table align=center border=1 cellPadding=1 cellSpacing=1 width=75% >
      <tr>
        <td>High-Low-Open-Close</td>
        <td>Candle</td>
        <td>Complex Candle</td>
      </tr>
      <tr>
        <td>
          <INPUT id=ShowOpenTick name=ShowOpenTick type=checkbox
            <% DemoCheckWriter(CurrentShowOpenTick) %> value="on">
          Open Tick Visible?<br>

          <INPUT id=ShowCloseTick name=ShowCloseTick type=checkbox
            <% DemoCheckWriter(CurrentShowCloseTick) %> value="on">
          Close Tick Visible?<br>

          Tick Length:
          <input id=TickLength name=TickLength
            value="<%= CurrentTickLength %>" size=2> 
        </td>
        <td>
          Candle Width:
          <input id=CandleWidth name=CandleWidth
            value="<%= CurrentCandleWidth %>" size=2>
        </td>

        <td>
          Candle Widths<br>

          Rising:
          <input id=RisingWidth name=RisingWidth
            value="<%= CurrentRisingWidth %>" size=3><br>

          Falling:
          <input id=FallingWidth name=FallingWidth
            value="<%= CurrentFallingWidth %>" size=3> 
        </td>
      </tr>
    </table>
  
    <p align=center>
      Please click <input type="submit" name="B1" value="Submit"> to
      see the changes reflected in the chart below: 
    </p>
  </form>
  
  <p align="center">
    <!--METADATA TYPE="DesignerControl" startspan
      <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5"
        height=330 width=536
        id=Chart2D1 style="HEIGHT: 330px; LEFT: 84px; TOP: 354px; WIDTH: 536px"
      >
        <PARAM NAME="PersistenceVersion" VALUE="1">
        <PARAM NAME="Language" VALUE="2">
        <PARAM NAME="TagRoutine" VALUE="">
        <PARAM NAME="ByteCount" VALUE="1532">
        <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E3244663700001B22000000000000020000000400000000000000FEFFFFFF02000000FF0003000000FFFFFFFF0000FF00">
        <PARAM NAME="Part1" VALUE="04000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200FFFFFF0014000000FFFFFFFFFFFFFF000200030000FF000007000000000000">
        <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF0200FFFF00000A000000FFFFFFFFFFFF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
        <PARAM NAME="Part3" VALUE="FF0200FF00000001000000FFFFFFFFFF00000002000500FF00000007000000000000000000000001010001000000085365726965732031000000000100000100">
        <PARAM NAME="Part4" VALUE="A0C8EB85F3CCE17F0400000005000000000000000000F03F00000000000034400000000000002040000000000000244000000000000030400000000000000040">
        <PARAM NAME="Part5" VALUE="00000000000036400000000000002840000000000000304000000000000033400000000000000840000000000000334000000000000024400000000000003140">
        <PARAM NAME="Part6" VALUE="0000000000002E400000000000001040000000000000384000000000000028400000000000002E40000000000000364000000000000014400000000000003940">
        <PARAM NAME="Part7" VALUE="0000000000002E400000000000003740000000000000324001000100020001000000000000000000060001000000000000000000000000000000000000000000">
        <PARAM NAME="Part8" VALUE="00000000000000000100000100A0C8EB85F3CCE17F00000000000000000000000001000200000000000000000000000000000000000300040000000E48696768">
        <PARAM NAME="Part9" VALUE="2D4C6F77204368617274FFFFFFFFFFFF00000001000000C50000000114000000010005417269616CA42C02000000000000000100900100000103000000020000">
        <PARAM NAME="Part10" VALUE="0000FFFFFFFFFFFFFFFF00010000000C0100000142010000010005417269616CC0D40100000000000000000090010000010300080004000000BFBFBF00FFFFFF">
        <PARAM NAME="Part11" VALUE="FF0001000000D9000000011C010000010005417269616C905F01000000000001000000BC02000000012000010000090004000000ABABAB000000000000010000">
        <PARAM NAME="Part12" VALUE="0000000000030004000000A1A1A100FFFF000000010000001A000000013F00000001E401000001D400000001000000003200000000FFFFFFFFFFFF0000020000">
        <PARAM NAME="Part13" VALUE="00000000000000010100030001000000000000000000010000000000000000E060400000000000000000000000000100FFFFFFFFFFFFFFFF00010000000F0000">
        <PARAM NAME="Part14" VALUE="000121000000011B000000010900000001000300000000000000000000F03F01000000000000144001000000000000E03F010000000000001640010000000000">
        <PARAM NAME="Part15" VALUE="00F03F01000000000000E03F010000000001000000000100000000000000E03F010000000000000000000400FFFF000001000000010200FFFFFF000100000002">
        <PARAM NAME="Part16" VALUE="00000825483A254D3A25530101000000000040F8D8400005417269616CDC7C01000000000001000000BC02000001000001000000000000000000000001000000">
        <PARAM NAME="Part17" VALUE="00000000000000000000000000000000002040010000000000003940010000000000001440010000000000003940010000000000001440010000000000000440">
        <PARAM NAME="Part18" VALUE="0100000000010000000001000000000000001440010000000000000000000400FFFF000001000000010200FFFFFF000100000002000000000000008056400100">
        <PARAM NAME="Part19" VALUE="05417269616CDC7C01000000000001000000BC0200000100000100000000000000000000000100000000000000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0">
        <PARAM NAME="Part20" VALUE="C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F0100000000010000000001000200FFFF0000010000000200010000000000">
        <PARAM NAME="Part21" VALUE="805640010005417269616CDC7C01000000000001000000BC02000001000001000000000000000000000001000000000000000000000000000000000000020000">
        <PARAM NAME="Part22" VALUE="00050000000000010000000100000001000000010000000000000000000000000000000000000001000000000101000500000000000100000001000000010000">
        <PARAM NAME="Part23" VALUE="000100000000000000000000000000000000000000010000000001020001010001000001000000000000001440000000000000344000010100010001">
      </OBJECT>
    -->
  </p>

  <%
    var Chart2D1;
    Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent");

    function Chart2D1_Load()
    {
      with(Chart2D1)
      {
        Width = 536;
        Height = 330;
        IsBatched = true;

        with(ChartArea)
        {
          with(Axes("X"))
          {
            AxisStyle.LineStyle.Color = 16777215;
            DemoInitFont(Font,9.75,true);
          }
          with(Axes("Y"))
          {
            AxisStyle.LineStyle.Color = 16777215;
            DemoInitFont(Font,9.75,true);
          }
          
          DemoInitFont(Axes("Y2").Font,9.75,true);

          with(Border)
          {
            Type = oc2dBorderShadow;
            Width = 4;
          }

          Candle.IsComplex = true;

          with(Interior)
          {
            BackgroundColor = 10592673;
            ForegroundColor = 65535;
          }
        }

        with(Border)
        {
          Type = oc2dBorderBevel;
          Width = 4;
        }

        Interior.BackgroundColor = 11250603;

        with(Header)
        {
          with(Border)
          {
            Type = oc2dBorderShadow;
            Width = 4;
          }

          DemoInitFont(Font,14.25,false);

          Interior.ForegroundColor = 65535;
          Text.Text = "High-Low Chart";
        }

        DemoInitFont(Footer.Font,12,false);

        with(Legend)
        {
          Anchor = oc2dAnchorSouth;

          with(Border)
          {
            Type = oc2dBorderFrameOut;
            Width = 4;
          }

          DemoInitFont(Font,9,true);

          Interior.BackgroundColor = 12566463;
        }

        with(ChartGroups(1))
        {
          ChartType = oc2dTypeHiLo;

          with(Styles(1))
          {
            with(Line)
            {
              Color = 16711680;
              Width = 3;
            }
            with(Fill)
            {
              Pattern = oc2dFill50Percent;
              Interior.ForegroundColor = 16711680;
            }
          }
          with(Styles(2))
          {
            with(Line)
            {

              Color = 16777215;
              Width = 20;
            }
            Fill.Interior.ForegroundColor = 16777215;
          }
          with(Styles(3))
          {
            with(Line)
            {
              Color = 65535;
              Width = 10;
            }
            Fill.Interior.ForegroundColor = 65535;
          }
          with(Styles(4))
          {
            Line.Color = 255;
            Fill.Interior.ForegroundColor = 255;
          }

          SeriesLabels.Add("Series 1");
        }
        IsBatched = false;
      }
    } 

    Chart2D1_Load();
  %>

  <!--METADATA TYPE="DesignerControl" endspan-->

  <%
    function setup_hilo()
    {
      with(Chart2D1)
      {
        Header.Text.Text = "High-Low Chart";

        with(ChartGroups(1))
        {
          ChartType = oc2dTypeHiLo;
          Data.SeriesDisplay(3) = oc2dDisplayHide;
          with(Styles(1).Line)
          {
            Color = ocColorBlue;
            Width = 3;
            Pattern = oc2dLineSolid;
          }
        }
      }
    }

    function setup_hloc()
    {
      with(Chart2D1)
      {
        Header.Text.Text = "High-Low-Open-Close Chart";

        with(ChartGroups(1))
        {
          ChartType = oc2dTypeHiLoOpenClose;
          Data.SeriesDisplay(3) = oc2dDisplayShow;
          with(Styles(1).Line)
          {
            Color = ocColorWhite;
            Width = 2;
            Pattern = oc2dLineSolid;
          }
          Styles(1).Symbol.Size = CurrentTickLength;
        }
      }
    }

    function setup_candle()
    {
      with(Chart2D1)
      {
        Header.Text.Text = "Candle Chart";
        ChartArea.Candle.IsComplex = false;
        
        with(ChartGroups(1))
        {
          ChartType = oc2dTypeCandle;
          Data.SeriesDisplay(3) = oc2dDisplayShow;

          with(Styles(1))
          {
            with(Line)
            {
              Color = ocColorRed;
              Width = 2;
              Pattern = oc2dLineSolid;
            }

            Fill.Pattern = oc2dFill50Percent;
            Symbol.Size = CurrentCandleWidth;
          }
        }
      }
    }

    function setup_complex_candle()
    {
      with(Chart2D1)
      {
        Header.Text.Text = "Complex Candle Chart";
        ChartArea.Candle.IsComplex = true;
      
        with(ChartGroups(1))
        {
          ChartType = oc2dTypeCandle;
          Data.SeriesDisplay(3) = oc2dDisplayShow;

          //Set the Hi-Lo Line attributes
          with(Styles(1).Line)
          {
            Color = ocColorBlack;
            Width = 1;
            Pattern = oc2dLineSolid;
          }

          //Set the Rising Candle attributes
          with(Styles(2).Line)
          {
            Color = ocColorWhite;
            Width = CurrentRisingWidth;
            Pattern = oc2dLineSolid;
          }

          //Set the Falling Candle attributes
          with(Styles(3).Line)
          {
            Color = ocColorYellow;
            Width = CurrentFallingWidth;
            Pattern = oc2dLineSolid;
          }

          //Set the Candle Outline attributes
          with(Styles(4).Line)
          {
            Color = ocColorRed;
            Width = 1;
            Pattern = oc2dLineSolid;
          }
        }
      }
    }

    // The Tick(s)
    with(Chart2D1.ChartArea.HiLoOpenClose)
    {
      IsShowingOpen = CurrentShowOpenTick;
      IsShowingClose = CurrentShowCloseTick;
    }

    // Chart Type
    if(Request.Form("ChartType") == "HLOC")
      setup_hloc();
    else if(Request.Form("ChartType") == "CANDLE")
      setup_candle();
    else if(Request.Form("ChartType") == "COMCAN")
      setup_complex_candle();
    else
      setup_hilo();

    DemoSeparator();
  %>
  
  <p align="center">
    <%
      var dispChart = Session("DispChart");
      if(dispChart == "Jpeg")
        OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png")
        OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1");
      else if(dispChart == "Png-BinaryWrite")
        OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1");
      else if(dispChart == "Jpeg-BinaryWrite")
        OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1");
      else
        OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1");
    %>
  </p>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        To switch between the different chart types, choose one of the
        Chart Types from the list box. Based on which chart type has been
        selected, various options become available:
        <ul>
          <li>For the <strong>High-Low</strong> Chart, no extra options are available.<br>
              For the <strong><strong>High-Low-</strong>Open-Close</strong> Chart,
              available options comprise opening/closing Tick Visible check boxes to
              turn off left/right tick marks; and entering a value in the Tick Length
              edit box to set the length of the tick marks (if they are visible). </li>

          <li>For the <strong>Candle</strong> Chart, users can enter a value in the Candle
              Width edit box to set the width of candles. </li>

          <li>For the <strong>Complex Candle</strong> Chart, available options include
              entering a value in the Rising edit box to set the width of candles
              represents increasing values, and entering a value in the Falling edit
              box to set the width of candles representing decreasing values.</li>
        </ul>
      </td>
    </tr>
  </table>

  <%
    DemoSeparator();
    DemoCopyrightAndSource();

    Chart2D1=0;
  %>

  </body>
</html>
