<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/utils.inc" -->

<html>

  <%
    Private Sub gen_select_entry(selector, value, label)
      Response.Write("<OPTION value=""" & value & """")
      If Request.Form(selector) = value Then 
        Response.Write("selected")
      End If
      Response.Write("> " & label & Chr(10))
    End Sub

    Private Sub gen_offset_input(id)
      Response.Write("<input " & id & " name=" & id & " value=")
      If Request.Form(id).Count = 0 Then
        Response.Write("0")
      Else
        Response.Write(Request.form(id))
      End If
      Response.Write(" size=3>" & Chr(10))
    End Sub

    Private Function get_current_offset(id)
      If Request.Form(id).Count = 0 Then
        get_current_offset = 0
      Else
        get_current_offset = Request.form(id)
      End If
    End Function

    Dim CurrentThresholdValue
    If Request.Form("ThresholdValue").Count = 0 Then
      CurrentThresholdValue = 0
    Else
      CurrentThresholdValue = Request.Form("ThresholdValue")
    End If

    Dim CurrentStartAngle
    If Request.Form("StartAngle").Count = 0 Then
      CurrentStartAngle = 135
    Else
      CurrentStartAngle = Request.Form("StartAngle")
    End If

    Dim CurrentChartLabels
    If Request.Form.Count = 0 Then
      ' Didn't get to the page via the 'submit' button.
      CurrentChartLabels = True
    ElseIf Request.Form("ChartLabels") = "ON" Then
      CurrentChartLabels = True
    Else
      CurrentChartLabels = False
    End If

    Dim CurrentShowOutlines
    If Request.Form.Count = 0 Then
      ' Didn't get to the page via the 'submit' button.
      CurrentShowOutlines = True
    ElseIf Request.Form("ShowOutlines") = "ON" Then
      CurrentShowOutlines = True
    Else
      CurrentShowOutlines = False
    End If
  %>

  <head>
    <title>ComponentOne WebChart 2D - Pie Chart</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    'Set up the page headers and titles
      Call DemoPageHeader                     ' utils.inc
      Call DemoTitle2D("Pie Chart Example")   ' utils.inc
  %>

  <form action="pie.asp" method="post" id="form1" name="form1">

    <p align=center>
      Pie Slice Offset Values:
    </p>
    
    <table align=center border=1 cellPadding=1 cellSpacing=1 width=80% >
      <tr align=center>
        <td>1: <%gen_offset_input("offset1")%></td>
        <td>2: <%gen_offset_input("offset2")%></td>
        <td>3: <%gen_offset_input("offset3")%></td>
        <td>4: <%gen_offset_input("offset4")%></td>
        <td>5: <%gen_offset_input("offset5")%></td>
      </tr>
      <tr align=center>
        <td>6: <%gen_offset_input("offset6")%></td>
        <td>7: <%gen_offset_input("offset7")%></td>
        <td>8: <%gen_offset_input("offset8")%></td>
        <td>Other: <%gen_offset_input("offset9")%></td>
        <td>&nbsp;</td>
      </tr>
    </table>
    <br><br>

    <table border=0 align=center width=80% cellpadding=5>
      <tr>
        <td>
          Pie Sorting Methods:
          <%
            Response.Write("<select name=""SortMethod"" size=1>" & Chr(10))
            Call gen_select_entry( "SortMethod", "NONE", "None (Data Order)")
            Call gen_select_entry( "SortMethod", "ASCEND", "Ascending")
            Call gen_select_entry( "SortMethod", "DESCEND", "Descending")
            Response.Write("</select>" & Chr(10))
          %>
        </td>
        <td>
          Starting Angle:
          <input id="StartAngle" name="StartAngle" value="<%= CurrentStartAngle %>" size="3">
        </td>
      </tr>
      <tr>
        <td>
          Threshold Method: 
          <%
            Response.Write("<select name=""ThresholdMethod"" size=1>" & Chr(10))
            Call gen_select_entry( "ThresholdMethod", "SLICE", "Slice Cutoff")
            Call gen_select_entry( "ThresholdMethod", "PERCENT", "Percentile")
            Response.Write("</select>" & Chr(10))
          %>
        </td>
        <td>
          Threshold Value:
          <input id="ThresholdValue" name="ThresholdValue"
            value="<%= CurrentThresholdValue %>" size="3">
        </td>
      </tr>
      <tr>
        <td>
          <input id="ChartLabels" name="ChartLabels" type="checkbox" 
            <% DemoCheckWriter(CurrentChartLabels) %> value="ON">
          Show Chart Labels?
        </td>
        <td>
          <input id="ShowOutlines" name="ShowOutlines" type="checkbox"
            <% DemoCheckWriter(CurrentShowOutlines) %> value="ON">
          Show outlines? &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
        </td>
      </tr>
    </table>
    <br><br>

    <p align=center>
      Please click <input type="submit" name="B1" value="Submit">
      to see the changes reflected in the chart below:
    </p>
  </form>

  <p align="center">
    <!--METADATA TYPE="DesignerControl" startspan
      <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" 
        id=Chart2D1 height=330 width=536
        style="HEIGHT: 399px; LEFT: 44px; TOP: 332px; WIDTH: 521px" 
      >
        <PARAM NAME="PersistenceVersion" VALUE="1">
        <PARAM NAME="TagRoutine" VALUE="">
        <PARAM NAME="ByteCount" VALUE="2632">
        <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E3244D93500003D29000000000000020000000800000000000000FEFFFFFF0200FF00000001000000FFFFFFFFFF000000">
        <PARAM NAME="Part1" VALUE="02000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
        <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
        <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF00000007000000000000000000000001010004000000FEFFFFFF02000000FF0001000000FFFFFFFF">
        <PARAM NAME="Part4" VALUE="0000FF0002000600FF00000007000000000000000000000001010005000000FEFFFFFF0200FF00FF0001000000FFFFFFFFFF00FF00020004000000CD00070000">
        <PARAM NAME="Part5" VALUE="00000000000000000001010006000000FEFFFFFF0200ADFF2F0001000000FFFFFFFFADFF2F0002000300FF00FF00070000000000000000000000010100070000">
        <PARAM NAME="Part6" VALUE="00FEFFFFFF02000000CD0001000000FFFFFFFF0000CD000200020087CEFA00070000000000000000000000010100090000000131013201330134013501360137">
        <PARAM NAME="Part7" VALUE="01380139000000003F00000100A0C8EB85F3CCE17F0800000001000000000000000000F03F0000000000003E4000000000000032400000000000003A40000000">
        <PARAM NAME="Part8" VALUE="000000244000000000000044400000000000003A4000000000000028400000000000804140010001000100010001000100010001000000000000000000030001">
        <PARAM NAME="Part9" VALUE="00000000000000000000000000000000000000000000000000000000004100000100A0C8EB85F3CCE17F00000000000000000000000002000200000000000000">
        <PARAM NAME="Part10" VALUE="0000000000000000000001000400000015436F6F6C2050696520436861727420537475666621DEB88700FFFFFFFF000100000088000000011000000001000541">
        <PARAM NAME="Part11" VALUE="7269616CC0D401000000000001000000BC02000001030000000200000000FFFFFFFFFFFFFFFF0001000000DD000000018B010000010005417269616CC0D40100">
        <PARAM NAME="Part12" VALUE="000000000000000090010000010300010003000000FFFFFFFFFFFFFFFF0001000000B9010000016A000000010005417269616CC0D40100000000000000000090">
        <PARAM NAME="Part13" VALUE="010000065365726965730101000100000000020000005F9EA00000000000000100000009000000030002000000FFEBCD00FFFFFFFF00010000000D4368617274">
        <PARAM NAME="Part14" VALUE="204C6162656C203100000000000000000000000000000000000000000000000001000000010000000100000001000000000005417269616C4442010000000000">
        <PARAM NAME="Part15" VALUE="00000000900100000101020000010300000001000100030002000000FFEBCD00FFFFFFFF00010000000D4368617274204C6162656C2032000000000000000000">
        <PARAM NAME="Part16" VALUE="00000000000000000000000000000001000000020000000100000001000000000005417269616C444201000000000000000000900100000101020000010A0000">
        <PARAM NAME="Part17" VALUE="0003000100030002000000FFEBCD00FFFFFFFF00010000000D4368617274204C6162656C20330000000000000000000000000000000000000000000000000100">
        <PARAM NAME="Part18" VALUE="0000030000000100000001000000000005417269616C444201000000000000000000900100000101020000010F00000003000100030002000000FFEBCD00FFFF">
        <PARAM NAME="Part19" VALUE="FFFF00010000000D4368617274204C6162656C203400000000000000000000000000000000000000000000000001000000040000000100000001000000000005">
        <PARAM NAME="Part20" VALUE="417269616C444201000000000000000000900100000101020000010F00000003000100030002000000FFEBCD00FFFFFFFF00010000000D4368617274204C6162">
        <PARAM NAME="Part21" VALUE="656C203500000000000000000000000000000000000000000000000001000000050000000100000001000000000005417269616C444201000000000000000000">
        <PARAM NAME="Part22" VALUE="900100000101020000010F00000003000100030002000000FFEBCD00FFFFFFFF00010000000D4368617274204C6162656C203600000000000000000000000000">
        <PARAM NAME="Part23" VALUE="000000000000000000000001000000060000000100000001000000000005417269616C444201000000000000000000900100000101020000010F000000030001">
        <PARAM NAME="Part24" VALUE="00030002000000FFEBCD00FFFFFFFF00010000000D4368617274204C6162656C2037000000000000000000000000000000000000000000000000010000000700">
        <PARAM NAME="Part25" VALUE="00000100000001000000000005417269616C444201000000000000000000900100000101020000010F00000003000100030002000000FFEBCD00FFFFFFFF0001">
        <PARAM NAME="Part26" VALUE="0000000D4368617274204C6162656C20380000000000000000000000000000000000000000000000000100000008000000010000000100000000000541726961">
        <PARAM NAME="Part27" VALUE="6C444201000000000000000000900100000101020000010F00000003000100000002000000FFFFFFFFFFFFFFFF00010000000B4F74686572204C6162656C0000">
        <PARAM NAME="Part28" VALUE="0000000000000000000000000000000000000000000001000000000000000100000001000000000005417269616CC0D401000000000000000000900100000101">
        <PARAM NAME="Part29" VALUE="020000010F00000003000100030004000000FFFFFFFFFFFFFFFF00010000001400000001410000000193010000013E010000010000000032000000054F746865">
        <PARAM NAME="Part30" VALUE="72FFFFFFFFFFFF000002000000000000000000010100030001000000000000000000010000000000000000E060401900000015000000000000000100FFFFFFFF">
        <PARAM NAME="Part31" VALUE="FFFFFFFF00010000000900000001090000000109000000010900000001000300000000000000000000F03F01000000000000F03F01000000000000F03F019A99">
        <PARAM NAME="Part32" VALUE="99999999F13F019A9999999999B93F019A9999999999A93F010100000001000000000100000000000000F03F0100000000000000000004000000000001000000">
        <PARAM NAME="Part33" VALUE="01020000000000010000000200010825483A254D3A25530101000000000040F8D8400005417269616CC0D4010000000000000000009001000001000001000000">
        <PARAM NAME="Part34" VALUE="00000000000000000100000000000000000000000000000000000000002440010000000000004440010000000000002440010000000000004440010000000000">
        <PARAM NAME="Part35" VALUE="00244001000000000000144001FFFFFFFF0100000000010000000000000024400100000000000000000004000000000001000000010200000000000100000002">
        <PARAM NAME="Part36" VALUE="00010000000000805640010005417269616CC0D401000000000000000000900100000100000100000000000000000000000100000000000000A0C8EB85F3CCE1">
        <PARAM NAME="Part37" VALUE="7F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F010000000001000000000100020000000000">
        <PARAM NAME="Part38" VALUE="010000000200010000000000805640010005417269616CC0D4010000000000000000009001000001000001000000000000000000000001000000000000000000">
        <PARAM NAME="Part39" VALUE="00000000000000000002000000050000000000010000000100000001000000010000000000000000000000000000000000000001000000000101000500000000">
        <PARAM NAME="Part40" VALUE="00010000000100000001000000010000000000000000000000000000000000000001000000000102000101000000000100000000000000144000000000000034">
        <PARAM NAME="Part41" VALUE="4000010100010000">
      </OBJECT>
  -->
  </p>

  <%
    Sub initChartLabel(label, index, offset, text)
      With label
        .Name = ""
        .AttachMethod = oc2dAttachDataIndex
        .Offset = offset
        .Adjust = oc2dAdjustLeft
        .IsConnected = True
        .AttachDataIndex.Series = index
        .Border.Type = oc2dBorderShadow
        .Interior.BackgroundColor = 13495295
        .Text.Text = text
        Call DemoInitFont(.Font,8.25,False)
      End With
    End Sub

    Dim Chart2D1
    Set Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent")

    Sub Chart2D1_Load()
      With Chart2D1
        .Width = 521
        .Height = 399
        .IsBatched = True

        With .ChartArea
          Call DemoInitFont(.Axes("X").Font,12,False)
          Call DemoInitFont(.Axes("Y").Font,12,False)
          Call DemoInitFont(.Axes("Y2").Font,12,False)

          With .Border
            .Type = oc2dBorderShadow
            .Width = 4
          End With

          .Pie.OtherLabel.Text = "Other"

          With .View3D
            .Depth = 25
            .Elevation = 21
          End With
        End With

        .Interior.BackgroundColor = 10526303

        With .Header
          .Border.Type = oc2dBorder3DOut
          .Border.Width = 4
          
          Call DemoInitFont(.Font,12,True)

          .Interior.BackgroundColor = 8894686
          .Text.Text = "Cool Pie Chart Stuff!"
        End With

        Call DemoInitFont(.Footer.Font,12,False)

        With .Legend
          With .Border
            .Type = oc2dBorder3DOut
            .Width = 3
          End With

          Call DemoInitFont(.Font,12,False)
          .Text.Text = "Series"
        End With

        With .ChartLabels
          Call initChartLabel(.Add,  1,  3, "Chart Label 1")
          Call initChartLabel(.Add,  2, 10, "Chart Label 2")
          Call initChartLabel(.Add,  3, 15, "Chart Label 3")
          Call initChartLabel(.Add,  4, 15, "Chart Label 4")
          Call initChartLabel(.Add,  5, 15, "Chart Label 5")
          Call initChartLabel(.Add,  6, 15, "Chart Label 6")
          Call initChartLabel(.Add,  7, 15, "Chart Label 7")
          Call initChartLabel(.Add,  8, 15, "Chart Label 8")
          Call initChartLabel(.Add,  0, 15, "Other Label")
        End With

        With .ChartGroups(1)
          .ChartType = oc2dTypePie
          
          With .Data
            .IsSaved = True
            .NumSeries = 8
            .NumPoints(1) = 1
            .X(1, 1) = 1
            .Y(1, 1) = 30
            .Y(2, 1) = 18
            .Y(3, 1) = 26
            .Y(4, 1) = 10
            .Y(5, 1) = 40
            .Y(6, 1) = 26
            .Y(7, 1) = 12
            .Y(8, 1) = 35
          End With

          With .SeriesLabels
            Call .Add("1")
            Call .Add("2")
            Call .Add("3")
            Call .Add("4")
            Call .Add("5")
            Call .Add("6")
            Call .Add("7")
            Call .Add("8")
            Call .Add("9")
          End With
        End With

        .IsBatched = False
      End With 
    End Sub 

    Call Chart2D1_Load()
  %>

  <!--METADATA TYPE="DesignerControl" endspan-->
  <p align="center">
    <% 
      Dim ind,cnt

      With Chart2D1
      
        cnt = .ChartLabels.Count
        For ind = 1 To cnt
          .ChartLabels(ind).IsShowing = CurrentChartLabels
        Next

        With .ChartArea
          .IsShowingOutlines = CurrentShowOutlines

          With .Pie
            .StartAngle = CurrentStartAngle

            ' Sorting Method
            If Request.Form("SortMethod") = "NONE" Then 
              .SortOrder = oc2dSortOrderNone
            ElseIf Request.Form("SortMethod") = "ASCEND" Then 
              .SortOrder = oc2dSortOrderAscending
            Else
              .SortOrder = oc2dSortOrderDescending
            End If

            ' Threshold Method & Value
            If Request.Form("ThresholdMethod") = "SLICE" Then 
              .ThresholdMethod = oc2dThresholdSliceCutoff
            Else
              .ThresholdMethod = oc2dThresholdPercentile
            End If

            .ThresholdValue = CurrentThresholdValue
          End With

        End With

        'Setup the PointStyles object to allow the exploding of Pie Slices
        With .ChartGroups(1).PointStyles
          With .Add(0, 1)
            .Slice.Offset.Value = get_current_offset("offset9")
          End With
          With .Add(1, 1)
            .Slice.Offset.Value = get_current_offset("offset1")
          End With
          With .Add(2, 1)
            .Slice.Offset.Value = get_current_offset("offset2")
          End With
          With .Add(3, 1)
            .Slice.Offset.Value = get_current_offset("offset3")
          End With
          With .Add(4, 1)
            .Slice.Offset.Value = get_current_offset("offset4")
          End With
          With .Add(5, 1)
            .Slice.Offset.Value = get_current_offset("offset5")
          End With
          With .Add(6, 1)
            .Slice.Offset.Value = get_current_offset("offset6")
          End With
          With .Add(7, 1)
            .Slice.Offset.Value = get_current_offset("offset7")
          End With
          With .Add(8, 1)
            .Slice.Offset.Value = get_current_offset("offset8")
          End With

          'Setup an extra PointStyle with a value other than 0 so the Pie Chart
          ' will remain the same size even when the Pie Slices are being dragged
          'Note: This value becomes the largest offset value allowed for a dragged slice

          With .Add(9, 1)
            .Slice.Offset = 50
          End With

        End With

      End With

      Call DemoSeparator()
    %>
  </p>

  <p align="center">
    <%
      Dim dispChart
      dispChart = Session("DispChart")
      If dispChart = "Jpeg" Then
        Call OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png" Then
        Call OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Jpeg-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1")
      Else
        Call OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1")
      End If
    %>
  </p>

  <table border=0 align=center width=90% >
    <font FACE="ARIAL">
      <tr>
        <td valign="top" >How to Use this Demo:
          <ul>
            <li>Use the Pie Sorting Methods list box to 
                change how the pie slices are sorted.</li>

            <li>Use the Chart Labels check box to control 
                the display of ChartLabels on the chart.</li>

            <li>Use the Threshold controls to specify how 
                to create the "other" slice, and the other slice threshold value.</li>

            <li>Use the Starting Angle value to specify the 
                angle at which the first slice for the first series is drawn.</li>

            <li>Use the Pie Slice Offset Values to offset a slice (including the
                "other" slice) from the center of the pie. (Offset is measured
                as a percentage of the radius of the pie.)</li>
          </ul>
        </td>
      </tr>
    </font>
  </table>

  <%
    Call DemoSeparator()
    Call DemoCopyrightAndSource()

    Set Chart2D1=Nothing
  %>
  </body>
</html>
