<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<html>

  <head>
    <title>ComponentOne WebChart 2D - VB Script Demos</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

    <table border="0" align="center" width="100%">
      <tbody>
        <font face="Tahoma">
          <tr>
            <td valign="center">
              <p align="left">
                <img src="c1chart8_sm.gif" border="0">
              </p>
            </td>
            <td valign="center">
              <p align="right">
                <a href="http://www.componentone.com">
                  <img src="logo_c1.gif" alt="http://www.componentone.com" border="0">
                </a>
              </p>
            </td>
          </tr>
        </font>
      </tbody>
    </table>

    <p align="center">
      <font color="#d70000" face="Tahoma">
        <big><big><big><strong>ComponentOne WebChart</strong></big></big></big>
      </font>
    </p>

    <p align="center">
      <font color="#d70000" face="Tahoma">
        <big><strong>Demos and Examples-VBScript</strong></big>
      </font>
    </p>

    <p align="center">
      <font face="Tahoma" color="#D70000">
        <strong>(Click <a href="jsdemos.asp">here</a> for JavaScript examples)</strong>
      </font>
    </p>

    <%
      Sub gen_select_entry(selector, value, label, defValue)
        Response.Write("<OPTION value=""" & value & """")
        If defValue = value Then Response.Write(" selected")
        Response.Write("> " & label & Chr(10))
      End Sub

      Function gen_chart_selector(selector, defValue)
        Response.Write("<select name=""" & selector & """ size=1 onchange=""form1.submit()"">" & Chr(10))
        Call gen_select_entry( selector, "ActiveX", "ActiveX", defValue)
        Call gen_select_entry( selector, "Png", "Png", defValue)
        Call gen_select_entry( selector, "Jpeg", "Jpeg", defValue)
        Call gen_select_entry( selector, "Png-BinaryWrite", "Png-BinaryWrite", defValue)
        Call gen_select_entry( selector, "Jpeg-BinaryWrite", "Jpeg-BinaryWrite", defValue)
        Response.Write("</select>")
      End Function

      Dim dispChart
      If Request.Form("chartdisplay").Count = 0 Then
        If Session("DispChart") = "" Then
          dispChart = "ActiveX"
        Else
          dispChart = Session("DispChart")
        End If
      Else
        dispChart = Request.Form("chartdisplay")(1)
      End If
      Session("DispChart") = dispChart
    %>

    <form action="default.asp" method="post" id=form1 name=form1>

    <table border="1" align="center" cellpadding="5">
      <tbody>
        <tr>
          <td valign="top" width="50%" height="25">
            <p align="center">
              <font color="#d70000" face="Tahoma">
                <big><strong>2D</strong></big>
              </font>
            </p>
          </td>
          <td valign="top" width="50%" height="25">
            <p align="center">
              <font color="#d70000" face="Tahoma">
                <big><strong>3D</strong></big>
              </font>
            </p>
          </td>
        </tr>
        <tr>
          <td valign="top" align="center" width="50%" height="19" COLSPAN="2">
            <p align=center><big><strong>
              Chart Display Method: <% gen_chart_selector "chartdisplay", dispChart %>
            </strong></big></p>
          </td>
        </tr>
        <tr>
          <td valign="top" width="50%" height="19">
            <font face="Tahoma">Simple ASP:<br>
              <a href="2d/demos/vbs/errorbar.asp">Error Bars</a><br>
              <a href="2d/demos/vbs/Radar.asp">Radar Chart</a><br>
              <a href="2d/demos/vbs/Alarmz.asp">AlarmZone Example</a>
            </font>
            <p>
              <font face="Tahoma">Using the 2D Design-Time Control:<br>
                <a href="2d/demos/vbs/Boxwhisk.asp">Box-and-Whisker</a><br>
                <a href="2d/demos/vbs/floatstack.asp">Floating Stacked Bars</a><br>
                <a href="2d/demos/vbs/hlcandle.asp">High-Low-Open-Close and Candle</a><br>
                <a href="2d/demos/vbs/Pie.asp">Pie Chart</a><br>
                <a href="2d/demos/vbs/Polar.asp">Polar Chart</a><br>
                <a href="2d/demos/vbs/ADOdemo.asp">Recordset</a> (ADO)<br>
                <a href="2d/demos/vbs/stocks.asp">Stock Charts</a>
              </font>
            </p>
          </td>
          <td valign="top" width="50%" height="19">
            <font face="Tahoma">Simple ASP:<br>
              <a href="3d/demos/vbs/scatter.asp">Scatter Chart</a>
            </font>
            <p>
              <font face="Tahoma">Using the 3D Design-Time Control:<br>
                <a href="3d/demos/vbs/DstRange.asp">Distribution Ranges</a>
              </font>
            </p>
          </td>
        </tr>
        <tr>
          <td valign="top" align="center" width="50%" height="19" COLSPAN="2">
            <big><strong>Binary streaming</strong></big><br>
          </td>
        </tr>
        <tr>
          <td valign="top" align="center" width="50%" height="19">
            <font face="Tahoma">
              <a href="2d/demos/vbs/BinStream.asp">Chart2D</a>
            </font>
          </td>
          <td valign="top" align="center" width="50%" height="19">
            <font face="Tahoma">
              <a href="3d/demos/vbs/BinStream.asp">Chart3D</a>
            </font>
          </td>
        </tr>
      </tbody>
    </table>
    </form>
    <br><br>

    <p align="center">
      <font size = -2 face="Arial">
        <a HREF="copyright.htm">Copyright</a> ComponentOne LLC
      </font>
    </p>

  </body>
</html>
