<%
//*****************************************************************************
//*
//* Copyright (c) ComponentOne LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* COMPONENTONE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. COMPONENTONE SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************


//---- ErrorConstants Values ----          Specifies the error detected by the chart.
var ocErrorInvalidIndex = 0;            // Invalid index found in variant
var ocErrorReadOnly = 1;                // Property is read-only and cannot be modified
var ocErrorOutOfRange = 2;              // Numeric value is out of range
var ocErrorInvalidEnum = 3;             // Invalid enumerated value for property
var ocErrorInvalidValue = 4;            // Invalid value for property
var ocErrorNoSuchProperty = 5;          // Property does not exist for this instance of the object
var ocErrorDuplicateValue = 6;          // Collection already contains a duplicate value
var ocErrorNoSuchItem = 7;              // Cannot find item in collection
var ocErrorCannotCreateObject = 8;      // Cannot create object
var ocErrorTypeMismatch = 9;            // Property set to wrong object type
var ocErrorReadOnlyWhenBound = 10;      // Property is read-only when the chart group is bound
var ocErrorBadArrayDimensions = 11;     // Wrong dimensions in SafeArray passed to a function
var ocErrorNotConnected = 12;           // Object does not have a parent
var ocErrorInvalidFormat = 13;          // Invalid custom format
var ocErrorDllNotCompatible = 14;       // DLL version is not compatible
var ocErrorSeriesArrayNotOne = 15;      // Series index must be 1 for Array data layout
%>
