<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/utils.inc" -->

<html>

  <head>
    <title>ComponentOne WebChart 2D - Floating Stacked Bars</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    Call DemoPageHeader()
    Call DemoTitle2D("Floating Stacked Bars Example")

    Sub gen_select_entry(selector, value, label)
      Response.Write("<OPTION value=""" & value & """")
      If Request.Form(selector) = value Then 
        Response.Write("selected")
      End If
      Response.Write("> " & label & Chr(10))
    End Sub

    Sub gen_selector(selector)
      Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
      Call gen_select_entry( selector, "SHOW", "Show")
      Call gen_select_entry( selector, "HIDE", "Hide")
      Call gen_select_entry( selector, "EXCLUDE", "Exclude")
      Response.Write("</select>")
    End Sub

    Function selector_to_enum(selector)
      If Request.Form(selector) = "HIDE" Then
        selector_to_enum = oc2dDisplayHide
      ElseIf Request.Form(selector) = "EXCLUDE" Then
        selector_to_enum = oc2dDisplayExclude
      Else
        selector_to_enum = oc2dDisplayShow
      End If
    End Function

    Dim CurrentReverseLegend
    CurrentReverseLegend = (Request.Form("ReverseLegend") = "ON")

    Dim CurrentHundredPercent
    CurrentHundredPercent = (Request.Form("HundredPercent") = "ON")
  %>

  <p align=center>
    Please indicate whether to show, hide or exclude each series.<br>
  </p>

  <table border=0 align=center cellpadding=1 cellspacing=1 style=width:50% width=50% >
    <tr>
      <td align=center>Series 1</td>
      <td align=center>Series 2</td>
      <td align=center>Series 3</td>
      <td align=center>Series 4</td>
    </tr>
  </table>

  <form action="FloatStack.asp" method="post" id="form1" name="form1">
    <table border=0 align=center cellSpacing=1 style=width:50% width=50% >
      <tr>
        <td align=center><% gen_selector("Series1") %></td>
        <td align=center><% gen_selector("Series2") %></td>
        <td align=center><% gen_selector("Series3") %></td>
        <td align=center><% gen_selector("Series4") %></td>
      </tr>
    </table>
    <br><br>
    <table border=0 align=center width=50% >
      <tr>
        <td>
          <input id="ReverseLegend" name="ReverseLegend" type="checkbox"
            <% DemoCheckWriter(CurrentReverseLegend) %> value="ON">
          Reverse the legend?
        </td>
        <td>
          <input id="HundredPercent" name="HundredPercent" type="checkbox" 
            <% DemoCheckWriter(CurrentHundredPercent) %> value="ON">
          100 percent? 
        </td>
      </tr>
    </table>
    <br><br>
    <table border=0 align=center width=90% >
      <tr align=center>
        <td>
          Please click <input type="submit" name="B1" value="Submit"> to see
          the changes reflected in the chart below:
        </td>
      </tr>
    </table>
  </form>

  <!--METADATA TYPE="DesignerControl" startspan
    <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" id=Chart2D1 height=401 width=601
      style="HEIGHT: 401px; LEFT: 0px; TOP: 0px; WIDTH: 601px">
      <PARAM NAME="PersistenceVersion" VALUE="1">
      <PARAM NAME="ByteCount" VALUE="1581">
      <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E32441E3E00007229000000000000020000000400000000000000FEFFFFFF0200FF00000001000000FFFFFFFFFF000000">
      <PARAM NAME="Part1" VALUE="02000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
      <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
      <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF000000070000000000000000000000010100040000000131013201330134000000006E00000100A0">
      <PARAM NAME="Part4" VALUE="C8EB85F3CCE17F0400000005000000000000000000F03F0000000000003440000000000000204000000000000024400000000000003040000000000000004000">
      <PARAM NAME="Part5" VALUE="00000000003640000000000000284000000000000030400000000000003340000000000000084000000000000033400000000000002440000000000000314000">
      <PARAM NAME="Part6" VALUE="00000000002E400000000000001040000000000000384000000000000028400000000000002E4000000000000036400000000000001440000000000000394000">
      <PARAM NAME="Part7" VALUE="00000000002E40000000000000374000000000000032400100010001000100000000000000000004000100000000000000000000000000000000000000000000">
      <PARAM NAME="Part8" VALUE="000000000000000000000100A0C8EB85F3CCE17F0000000000000000000000000200020000000000000000000000000000000000030004000000355573652074">
      <PARAM NAME="Part9" VALUE="686520436865636B20426F7865732041626F766520746F2048696465206F72204578636C756465206120536572696573FFFFE000FFFFFFFF00010000003B0000">
      <PARAM NAME="Part10" VALUE="000111000000010005417269616CC0D4010000000000000000009001000001030000000200000000FFFFFFFFFFFFFFFF00010000000501000001890100000100">
      <PARAM NAME="Part11" VALUE="05417269616CC0D40100000000000000000090010000010300050003000000FFFFFFFFFFFFFFFF000100000007020000018D000000010005417269616CC0D401">
      <PARAM NAME="Part12" VALUE="0000000000000000009001000006536572696573010100010000090004000000ADD8E6000000000000010000000000000003000500000098FB9800FFFFFFFF00">
      <PARAM NAME="Part13" VALUE="0100000019000000013D00000001D90100000142010000010000000032000000054F74686572FFFFFFFFFFFF0000020000000000000000000101000300010000">
      <PARAM NAME="Part14" VALUE="00000000000000010000000000000000E060400A0000000A0000000A0000000100FFFFFFFFFFFFFFFF0001000000100000000124000000012800000001090000">
      <PARAM NAME="Part15" VALUE="0001000300000000000000000000F03F01000000000000144001000000000000E03F01000000000000164001000000000000F03F01000000000000E03F010000">
      <PARAM NAME="Part16" VALUE="000001000000000100000000000000E03F010000000000000000000400000000000100000001020000000000010000000200010825483A254D3A255301010000">
      <PARAM NAME="Part17" VALUE="00000040F8D8400005417269616CC0D4010000000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000">
      <PARAM NAME="Part18" VALUE="0000000001000000000040544001000000000000000001000000000000594001000000000000344001000000000000244001FFFFFFFF01000000000100000000">
      <PARAM NAME="Part19" VALUE="0000000000010000000000000000000400000000000100000001020000000000010000000200010000000000805640010005417269616CC0D401000000000000">
      <PARAM NAME="Part20" VALUE="000000900100000100000100000000000000000000000100000000000000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE1">
      <PARAM NAME="Part21" VALUE="7F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F010000000001000000000100020000000000010000000200010000000000805640010005417269616CC0D40100">
      <PARAM NAME="Part22" VALUE="00000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000020000000500000000000100000001000000">
      <PARAM NAME="Part23" VALUE="01000000010000000000000000000000000000000000000001000000000101000500000000000100000001000000010000000100000000000000000000000000">
      <PARAM NAME="Part24" VALUE="000000000000010000000001020001010000000001000000000000001440000000000000344000010100010000">
    </OBJECT>
  -->
  <!--METADATA TYPE="DesignerControl" endspan-->

  <%
    Dim Chart2D1
    Set Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent")

    Sub Chart2D1_Load()
      With Chart2D1
        .Width = 600
        .Height = 400
        .IsBatched = True
      
        With .ChartArea
          Call DemoInitFont(.Axes("X").Font,12,False)
          Call DemoInitFont(.Axes("Y").Font,12,False)
          Call DemoInitFont(.Axes("Y2").Font,12,False)
          
          With .Border
            .Type = oc2dBorderShadow
            .Width = 5
          End With

          .Interior.BackgroundColor = 10025880
          .Pie.OtherLabel.Text = "Other"

          With .View3D
            .Depth = 10
            .Elevation = 10
            .Rotation = 10
          End With
        End With

        With .Border
          .Type = oc2dBorderBevel
          .Width = 4
        End With

        .Interior.BackgroundColor = 15128749

        With .Header
          With .Border
            .Type = oc2dBorderShadow
            .Width = 4
          End With
          Call DemoInitFont(.Font,12,False)

          .Interior.BackgroundColor = 14745599
        
          .Text.Text = "Use the Check Boxes Above to Hide or Exclude a Series"
        End With

        Call DemoInitFont(.Footer.Font,12,False)
        
        With .Legend
          With .Border
            .Type = oc2dBorderEtchedIn
            .Width = 3
          End With
          Call DemoInitFont(.Font,12,False)
          .Text.Text = "Series"
        End With

        With .ChartGroups(1)
          .ChartType = oc2dTypeStackingBar
          With .SeriesLabels
            Call .Add("1")
            Call .Add("2")
            Call .Add("3")
            Call .Add("4")
          End With
        End With

        With .ChartGroups(2)
          .ChartType = oc2dTypeBar
          .Data.IsSaved = False
        End With
        
        .IsBatched = False
      End With
    End Sub 

    Call Chart2D1_Load()

    With Chart2D1
      .Legend.IsReversed = CurrentReverseLegend 
      .ChartArea.Axes("Y").Is100Percent = CurrentHundredPercent 
  
      ' Set the display mode for each series. 
      With .ChartGroups(1).Data
        .SeriesDisplay(1) = selector_to_enum("Series1") 
        .SeriesDisplay(2) = selector_to_enum("Series2") 
        .SeriesDisplay(3) = selector_to_enum("Series3") 
        .SeriesDisplay(4) = selector_to_enum("Series4") 
      End With
    End With

    Call DemoSeparator()
  %>

  <p align=center>
    <%
      Dim dispChart
      dispChart = Session("DispChart")
      If dispChart = "Jpeg" Then
        Call OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png" Then
        Call OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Jpeg-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1")
      Else
        Call OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1")
      End If
    %>
  </p>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        Interaction with this demo is performed using the Show/Hide/Exclude
        list boxes and the two check boxes. Specifically:
        <ul>
          <li>The &quot;Reverse the legend&quot; option toggles the displayed order of the Legend. </li>
          <li>The &quot;100 percent&quot; option toggles the axis property that treats values within a
            series as percentages of a 100% total. </li>
          <li>The Hide list box entries are used to hide a series -- the series is not drawn, but the
            chart still leaves room for it. </li>
          <li>The Exclude list box entries are used to exclude a series -- the series is not drawn and
            the chart does not leave room for it (that is, the series is now treated as nonexistent). </font></li>
        </ul>
      </td>
    </tr>
  </table>

  <%
    Call DemoSeparator()
    Call DemoCopyrightAndSource()
    Set Chart2D1 = Nothing
  %>

  </body>
</html>
