<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/utils.inc" -->

<html>
  <% 
    Sub gen_select_entry(value, label)
      Response.Write("<OPTION value=""" & value & """")
      If Request.Form("formula1") = value Then 
        Response.Write("selected")
      End If
      Response.Write("> r = " & label & Chr(10))
    End Sub

    Dim CurrentAnnoAngle
    If Request.Form("AnnoAngle").Count = 0 Then 
      CurrentAnnoAngle = 90
    Else
      CurrentAnnoAngle = Request.Form("AnnoAngle")(1)
    End If

    Dim CurrentHalfRange
    CurrentHalfRange = (Request.Form("HalfRange") = "ON")

    Dim CurrentOriginBase
    If Request.Form("OriginBase").Count = 0 Then 
      CurrentOriginBase = 0
    Else
      CurrentOriginBase = Request.Form("OriginBase")(1)
    End If
  %>

  <head>
    <title>ComponentOne WebChart 2D -Polar Chart</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    'Set up the page headers and titles
    Call DemoPageHeader                     ' utils.inc
    Call DemoTitle2D("Polar Chart Example") ' utils.inc
  %>

  <form action="polar.asp" method="post" id="form1" name="form1">

    <table border=0 align=center width=80% >
      <tr>
        <td>
          Annotation Angle:
          <input id="AnnoAngle" name="AnnoAngle" value="<%= CurrentAnnoAngle %>" size="3">
          &nbsp;&nbsp;&nbsp;&nbsp;
        </td>
        <td>
          <input id="HalfRange" name="HalfRange" type="checkbox"
            <% DemoCheckWriter(CurrentHalfRange) %> value="ON">
          Half Range?
        </td>
      </tr>
      <tr>
        <td>
          Origin Base:
          <input id="OriginBase" name="OriginBase" value="<%= CurrentOriginBase %>" size="3">
          &nbsp;&nbsp;&nbsp;&nbsp;
        </td>
        <td>
          Formula:
          <%
            Response.Write("<SELECT id=formula1 name=formula1>" & Chr(10))
            Call gen_select_entry( "0", "3 * Cos((2 * x) * Pi / 180)")
            Call gen_select_entry( "1", "1 - 2 * Cos(x * Pi / 180)")
            Call gen_select_entry( "2", "1 + 2 * Cos(x * Pi / 180)")
            Call gen_select_entry( "3", "2 / (2 - Cos(x * Pi / 180))")
            Call gen_select_entry( "4", "1 * Pi / 180")
            Call gen_select_entry( "5", "3 * (1 - Cos(x * Pi / 180)")
            Call gen_select_entry( "6", "2 + 3 * Sin(x * Pi / 180)")
            Call gen_select_entry( "7", "3 - 2 * Cos(x * Pi / 180)")
            Call gen_select_entry( "8", "3 * Sin(x * Pi / 180)")
            Call gen_select_entry( "9", "2 * Cos((3 * x) * Pi / 180)")
            Call gen_select_entry( "10", "3 * Cos((2 * x) * Pi / 180)")
            Call gen_select_entry( "11", "4 * Cos((2 * x) * Pi / 180)")
            Call gen_select_entry( "12", "4 + 5 * Cos(x * Pi / 180)")
            Call gen_select_entry( "13", "5 - 4 * Sin(x * Pi / 180)")
            Call gen_select_entry( "14", "3 * Cos(x * Pi / 180)")
            Call gen_select_entry( "15", "4 * Sin((2 * x) * Pi / 180)")
            Call gen_select_entry( "16", "-Sin((5 * x) * Pi / 180)")
            Call gen_select_entry( "17", "4 * Sin(x * Pi / 180)")
            Call gen_select_entry( "18", "Cos(3 * (x * Pi / 180))")
            Call gen_select_entry( "19", "4 / (6 + Sin(x * Pi / 180))")
            Call gen_select_entry( "20", "Sin(3*(x * Pi / 180))")
            Response.Write("</select>" & Chr(10))
          %>
        </td>
      </tr>
    </table>
    <br>
      
    <table border=0 align=center width=80% >
      <tr align=center>
        <td>
          <input type="submit" name="B1" value="Generate the chart">
        </td>
      </tr>
    </table>

  </form>
  
  <p align="center">
    <!--METADATA TYPE="DesignerControl" startspan
      <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" height=505 width=625
        id=Chart2D1 style="HEIGHT: 505px; LEFT: 0px; TOP: 0px; WIDTH: 625px">
        <PARAM NAME="PersistenceVersion" VALUE="1">
        <PARAM NAME="TagRoutine" VALUE="">
        <PARAM NAME="ByteCount" VALUE="1520">
        <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E3244994000003134000000000000020000000400000000000000FEFFFFFF0200FF00000002000000FFFFFFFFFF000000">
        <PARAM NAME="Part1" VALUE="02000100FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
        <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
        <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF00000007000000000000000000000001010000000000000000000100000100A0C8EB85F3CCE17F04">
        <PARAM NAME="Part4" VALUE="00000005000000000000000000F03F00000000000034400000000000002040000000000000244000000000000030400000000000000040000000000000364000">
        <PARAM NAME="Part5" VALUE="000000000028400000000000003040000000000000334000000000000008400000000000003340000000000000244000000000000031400000000000002E4000">
        <PARAM NAME="Part6" VALUE="00000000001040000000000000384000000000000028400000000000002E400000000000003640000000000000144000000000000039400000000000002E4000">
        <PARAM NAME="Part7" VALUE="00000000003740000000000000324001000100010001000000000000000000090001000000000000000000000000000000000000000000000000000000000001">
        <PARAM NAME="Part8" VALUE="00000100A0C8EB85F3CCE17F00000000000000000000000001000200000000000000000000000000000000000000020000000B506F6C6172204368617274FFFF">
        <PARAM NAME="Part9" VALUE="FFFFFFFFFFFF000100000014010000010C000000010005417269616CDC7C01000000000001000100BC02000001030000000200000000FFFFFFFFFFFFFFFF0001">
        <PARAM NAME="Part10" VALUE="0000003801000001F9010000010005417269616CC0D40100000000000000000090010000010300000002000000FFFFFFFFFFFFFFFF00010000006402000001FC">
        <PARAM NAME="Part11" VALUE="000000010005417269616CC0D401000000000000000000900100000001010001000000000000000000000000FFFFFF00000100000000000000000002000000FF">
        <PARAM NAME="Part12" VALUE="FFFFFFFFFFFFFF00010000001A000000012F000000013D02000001B701000001000000003200000000FFFFFFFFFFFF0000020000000000000000000101000300">
        <PARAM NAME="Part13" VALUE="01000000000000000000010000000000000000E060400000000000000000000000000100FFFFFFFFFFFFFFFF0001000000250000000125000000012E00000001">
        <PARAM NAME="Part14" VALUE="1C00000001000300000000000000000000F03F010000000000001440010000000000000000010000000000807640010000000000003E40010000000000002E40">
        <PARAM NAME="Part15" VALUE="0100000000010000000001000000000000805640010000000000000000000400FFFFFF0001000000010200FFFFFF00010000000200010825483A254D3A255301">
        <PARAM NAME="Part16" VALUE="01000000000040F8D8400005417269616CC0D4010000000000000000009001000001000001000000000000000000000001000000000000000000000000000000">
        <PARAM NAME="Part17" VALUE="00000000002040010000000000003940010000000000001440010000000000003940010000000000001440010000000000000440010000000001000000000100">
        <PARAM NAME="Part18" VALUE="0000000000003940010000000000000000000400FFFFFF0001000000010200FFFF0000010000000200000000000000805640010005417269616CC0D401000000">
        <PARAM NAME="Part19" VALUE="000000000000900100000100000100000000000000000000000100000000000000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85">
        <PARAM NAME="Part20" VALUE="F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F0100000000010000000001000200FFFFFF00010000000200010000000000805640010005417269616CC0">
        <PARAM NAME="Part21" VALUE="D4010000000000000000009001000001000001000000000000000000000001000000000000000000000000000000000000020000000500000000000100000001">
        <PARAM NAME="Part22" VALUE="00000001000000010000000000000000000000000000000000000001000000000101000500000000000100000001000000010000000100000000000000000000">
        <PARAM NAME="Part23" VALUE="000000000000000000010000000001020001010000000001000000000000001440000000000000344000010100010001">
      </OBJECT>
    -->

    <%
      Dim Chart2D1
      Set Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent")

      Sub Chart2D1_Load()
        With Chart2D1
          .Width = 600
          .Height = 485
          .IsBatched = True

          With .ChartArea
            Call DemoInitFont(.Axes("X").Font,12,False)

            With .Axes("Y")
              .AxisStyle.LineStyle.Color = 65535
              Call DemoInitFont(.Font,12,False)
            End With

            Call DemoInitFont(.Axes("Y2").Font,12,False)
          End With

          .Border.Width = 0

          With .Interior
            .BackgroundColor = 0
            .ForegroundColor = 16777215
          End With

          With .Header
            Call DemoInitFont(.Font,9.75,True)
            .Text.Text = "Polar Chart"
          End With

          Call DemoInitFont(.Footer.Font,12,False)
          Call DemoInitFont(.Legend.Font,12,False)

          With .ChartGroups(1)
            .ChartType = oc2dTypePolar
            With .Styles(1)
              .Line.Width = 2
              .Symbol.Shape = oc2dShapeNone
            End With
          End With

          .IsBatched = False
        End With
      End Sub 

      Call Chart2D1_Load()

    %>

    <!--METADATA TYPE="DesignerControl" endspan-->
  </p>
  
  <p align="center">
    <%
      Const Pi = 3.14159
      Const nPnts = 360

      Sub apply_formula()
        Dim x

        With Chart2D1
          'Batch all the updates to the chart to make all changes occur at once
          .IsBatched = True

          'Determine which formula was selected and generate the chart
          With .ChartGroups(1).Data

            For x = 1 To nPnts
              .X(1, x) = x
            Next

            Select Case Request.Form("formula1")

              Case 0    '  "r = 3 * Cos((2 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 * Cos((2 * x) * Pi / 180)
                Next

              Case 1    '  "r = 1 - 2 * Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 1 - 2 * Cos(x * Pi / 180)
                Next

              Case 2    '  "r = 1 + 2 * Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 1 + 2 * Cos(x * Pi / 180)
                Next


              Case 3    '  "r = 2 / (2 - Cos(x * Pi / 180))"
                For x = 1 To nPnts
                  .Y(1, x) = 2 / (2 - Cos(x * Pi / 180))
                Next

              Case 4    '  "r = 1 * Pi / 180"
                For x = 1 To nPnts
                  .Y(1, x) = 1 * Pi / 180
                Next

              Case 5    '  "r = 3 * (1 - Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 * (1 - Cos(x * Pi / 180))
                Next

              Case 6    '  "r = 2 + 3 * Sin(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 2 + 3 * Sin(x * Pi / 180)
                Next

              Case 7    '  "r = 3 - 2 * Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 - 2 * Cos(x * Pi / 180)
                Next

              Case 8    '  "r = 3 * Sin(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 * Sin(x * Pi / 180)
                Next

              Case 9    '  "r = 2 * Cos((3 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 2 * Cos((3 * x) * Pi / 180)
                Next

              Case 10   '  "r = 3 * Cos((2 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 * Cos((2 * x) * Pi / 180)
                Next

              Case 11   '  "r = 4 * Cos((2 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 4 * Cos(2 * (x * Pi / 180))
                Next

              Case 12   '  "r = 4 + 5 * Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 4 + 5 * Cos(x * Pi / 180)
                Next

              Case 13   '  "r = 5 - 4 * Sin(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 5 - 4 * Sin(x * Pi / 180)
                Next

              Case 14   '  "r = 3 * Cos(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 3 * Cos(x * Pi / 180)
                Next

              Case 15   '  "r = 4 * Sin((2 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 4 * Sin((2 * x) * Pi / 180)
                Next

              Case 16   '  "r = -Sin((5 * x) * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = -Sin((5 * x) * Pi / 180)
                Next

              Case 17   '  "r = 4 * Sin(x * Pi / 180)"
                For x = 1 To nPnts
                  .Y(1, x) = 4 * Sin(x * Pi / 180)
                Next

              Case 18   '  "r = Cos(3 * x) * Pi / 180"
                For x = 1 To nPnts
                  .Y(1, x) = Cos(3 * (x * Pi / 180))
                Next

              Case 19   '  "r = 4 / (6 + Sin(x * Pi / 180))"
                For x = 1 To nPnts
                  .Y(1, x) = 4 / (6 + Sin(x * Pi / 180))
                Next

              Case 20   '  "r = Sin(3 * (x * Pi / 180))"
                For x = 1 To nPnts
                  .Y(1, x) = Sin(3 * (x * Pi / 180))
                Next
            End Select
          End With

          'Resume regular Chart updates
          .IsBatched = False
        End With
      End Sub

      With Chart2D1
        With .ChartGroups(1).Data
          ' We want 1 series with nPnts points
          .NumSeries = 1
          .NumPoints(1) = nPnts
        End With
        
        With .ChartArea
          ' Handle the input boxes and the checkbox
          .Polar.IsHalfRange = CurrentHalfRange
          .Axes("Y").AnnotationAngle = CurrentAnnoAngle
          .Axes("X").OriginBase = CurrentOriginBase
        End With
      End With

      ' Apply the selected formula
      Call apply_formula()

      Call DemoSeparator()
    %>
  </p>
 
  <p align=center>
    <%
      Dim dispChart
      dispChart = Session("DispChart")
      If dispChart = "Jpeg" Then
        Call OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png" Then
        Call OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Jpeg-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1")
      Else
        Call OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1")
      End If
    %>
  </p>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        This example shows how to create a Polar Chart. This example also
        shows how to change the color of chart elements, including the
        axis and data series.
      </td>
    </tr>
  </table>

  <%
    Call DemoSeparator()
    Call DemoCopyrightAndSource()

    Set Chart2D1 = Nothing
  %>
  </body>
</html>
