<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/2dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/utils.inc" -->

<html>

  <head>
    <title>ComponentOne WebChart 2D - Stock Chart Example</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    Call DemoPageHeader()
    Call DemoTitle2D("Stock Chart Example")

    Sub gen_select_entry(selector, value, label)
      Response.Write("<OPTION value=""" & value & """")
      If Request.Form(selector) = value Then Response.Write("selected")
      Response.Write("> " & label & Chr(10))
    End Sub

    Sub gen_timeframe_selector(selector)
      Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
      Call gen_select_entry( selector, "2Y", "2 Years")
      Call gen_select_entry( selector, "1Y", "1 Year")
      Call gen_select_entry( selector, "6M", "6 Months")
      Call gen_select_entry( selector, "3M", "3 Months")
      Response.Write("</select>")
    End Sub

    Sub gen_exchange_selector(selector)
      Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
      Call gen_select_entry( selector, "ALL", "Show all indices")
      Call gen_select_entry( selector, "BDIA", "Bob & Doug's Industrial Average")
      Call gen_select_entry( selector, "GSE", "Gotham Stock Exchange 500")
      Call gen_select_entry( selector, "CTSI", "Cool Tech Stock Index")
      Response.Write("</select>")
    End Sub
  %>

  <table border=0 align=center width=90% >
    <tr><td><font face="Arial" size=4>
      <u>SlightlySoft Corp</u>. (SSFT)
    </font></td></tr>
  </table>
  <br>

  <!--METADATA TYPE="DesignerControl" startspan
  <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" height=375 id=Chart2D1 
    style="HEIGHT: 375px; LEFT: 0px; TOP: 0px; WIDTH: 744px" width=744>
    <PARAM NAME="PersistenceVersion" VALUE="1">
    <PARAM NAME="TagRoutine" VALUE="">
    <PARAM NAME="ByteCount" VALUE="1563">
    <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E3244E54C0000C226000000000000020000000400000000000000FEFFFFFF0200FF00000001000000FFFFFFFFFF000000">
    <PARAM NAME="Part1" VALUE="02000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
    <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
    <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF00000007000000000000000000000001010000000000000000000100000100A0C8EB85F3CCE17F04">
    <PARAM NAME="Part4" VALUE="00000005000000000000000000F03F00000000000034400000000000002040000000000000244000000000000030400000000000000040000000000000364000">
    <PARAM NAME="Part5" VALUE="000000000028400000000000003040000000000000334000000000000008400000000000003340000000000000244000000000000031400000000000002E4000">
    <PARAM NAME="Part6" VALUE="00000000001040000000000000384000000000000028400000000000002E400000000000003640000000000000144000000000000039400000000000002E4000">
    <PARAM NAME="Part7" VALUE="00000000003740000000000000324001000100010001000000000000000000070001000000000000000000000000000000000000000000000000000000000001">
    <PARAM NAME="Part8" VALUE="00000100A0C8EB85F3CCE17F000000000000000000000000010002000000000000000000000000000000000000000200000000FFFFFFFFFFFFFFFF0001000000">
    <PARAM NAME="Part9" VALUE="74010000010200000001000F54696D6573204E657720526F6D616EC0D4010000000000000000009001000001030000000200000000FFFFFFFFFFFFFFFF000100">
    <PARAM NAME="Part10" VALUE="000074010000017301000001000F54696D6573204E657720526F6D616EC0D40100000000000000000090010000010300000002000000FFFFFFFFFFFFFFFF0001">
    <PARAM NAME="Part11" VALUE="000000D802000001B900000001000F54696D6573204E657720526F6D616EC0D4010000000000000000009001000000010100010000000002000000FFFFFF0000">
    <PARAM NAME="Part12" VALUE="000000000100000000000000000002000000FFFFFFFFFFFFFFFF000100000020000000011100000001A8020000015501000001000000003200000000FFFFFFFF">
    <PARAM NAME="Part13" VALUE="FFFF000002000000000000000000010100030001000000000000000000010000000000000000E060400000000000000000000000000100FFFFFFFFFFFFFFFF00">
    <PARAM NAME="Part14" VALUE="01000000110000000113000000011E000000010A00000001000300000000000000000000F03F01000000000000144001000000000000E03F0100000000000016">
    <PARAM NAME="Part15" VALUE="4001000000000000F03F01000000000000E03F010000000001000000000100000000000000E03F01000000000000F03F01040000000000010000000102000000">
    <PARAM NAME="Part16" VALUE="0000010000000200010225620004000000000020A8E140000F54696D6573204E657720526F6D616EC0D401000000000000000000900100000100000100000000">
    <PARAM NAME="Part17" VALUE="00000000000300010000000000000000000000000000000000000000204001000000000000394001000000000000144001000000000000394001000000000000">
    <PARAM NAME="Part18" VALUE="14400100000000000004400100000000010000000001000000000000001440010000000000001440010400000000000100000001020000000000010000000200">
    <PARAM NAME="Part19" VALUE="01000000000080564001000F54696D6573204E657720526F6D616EC0D40100000000000000000090010000010000010000000000000000000000010000000000">
    <PARAM NAME="Part20" VALUE="0000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F010000000001000000">
    <PARAM NAME="Part21" VALUE="00010002000000000001000000020001000000000080564001000F54696D6573204E657720526F6D616EC0D40100000000000000000090010000010000010000">
    <PARAM NAME="Part22" VALUE="00000000000000000001000000000000000000000000000000000000020000000500000000000100000001000000010000000100000000000000000000000000">
    <PARAM NAME="Part23" VALUE="00000000000001000000000101000500000000000100000001000000010000000100000000000000000000000000000000000000010000000001020001010000">
    <PARAM NAME="Part24" VALUE="000001000000000000001440000000000000344000010100010001"></OBJECT>
  -->
  <%
    Dim Chart2D1
    Set Chart2D1 = Server.CreateObject("C1Chart2D8.ASPComponent")

    Sub Chart2D1_Load()
      With Chart2D1
        .Width = 600
        .Height = 340
        .IsBatched = True

        With .ChartArea
          With .Axes("X")
            .AnnotationMethod = oc2dAnnotateTimeLabels
            With .TimeScale
              .Unit = oc2dTimeDays
              .Base = 36161
              .Format.Value = "%b"
            End With
            Call DemoInitFont(.Font,12,False)
          End With

          Call DemoInitFont(.Axes("Y").Font,12,False)
          Call DemoInitFont(.Axes("Y2").Font,12,False)
        End With

        Call DemoInitFont(.Header.Font,12,False)
        Call DemoInitFont(.Footer.Font,12,False)
        Call DemoInitFont(.Legend.Font,12,False)

        .ChartGroups(1).ChartType = oc2dTypeHiLoOpenClose
        .IsBatched = False
      End With
    End Sub 

    Call Chart2D1_Load()
  %>
  <!--METADATA TYPE="DesignerControl" endspan-->

  <br>

  <!--METADATA TYPE="DesignerControl" startspan
  <OBJECT classid="clsid:93A917E7-0296-4408-B731-7606D83DCFC5" height=255 id=Chart2D2 
    style="HEIGHT: 255px; LEFT: 0px; TOP: 0px; WIDTH: 744px" width=744>
    <PARAM NAME="PersistenceVersion" VALUE="1">
    <PARAM NAME="TagRoutine" VALUE="">
    <PARAM NAME="ByteCount" VALUE="1585">
    <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E3244E54C00005B1A000000000000020000000400000000000000FEFFFFFF0200FF00000001000000FFFFFFFFFF000000">
    <PARAM NAME="Part1" VALUE="02000400FF00FF0007000000000000000000000001010001000000FEFFFFFF0200D2B48C0001000000FFFFFFFFD2B48C000200030000FF000007000000000000">
    <PARAM NAME="Part2" VALUE="000000000001010002000000FEFFFFFF020032FF000001000000FFFFFFFF32FF0000020002000000CD0007000000000000000000000001010003000000FEFFFF">
    <PARAM NAME="Part3" VALUE="FF020048D1CC0001000000FFFFFFFF48D1CC0002000500FF00000007000000000000000000000001010000000000000000000100000100A0C8EB85F3CCE17F04">
    <PARAM NAME="Part4" VALUE="00000005000000000000000000F03F00000000000034400000000000002040000000000000244000000000000030400000000000000040000000000000364000">
    <PARAM NAME="Part5" VALUE="000000000028400000000000003040000000000000334000000000000008400000000000003340000000000000244000000000000031400000000000002E4000">
    <PARAM NAME="Part6" VALUE="00000000001040000000000000384000000000000028400000000000002E400000000000003640000000000000144000000000000039400000000000002E4000">
    <PARAM NAME="Part7" VALUE="00000000003740000000000000324001000100010001000000000000000000020001000000000000000000000000000000000000000000000000000000000001">
    <PARAM NAME="Part8" VALUE="00000100A0C8EB85F3CCE17F0000000000000000000000000100020000000000000000000000000000000000050002000000164461696C7920566F6C756D6573">
    <PARAM NAME="Part9" VALUE="0D0A28273030307329FFFFFFFFFFFFFFFF000100000044010000011000000001000F54696D6573204E657720526F6D616EC0D401000000000000000000900100">
    <PARAM NAME="Part10" VALUE="0001030000000200000000FFFFFFFFFFFFFFFF00010000007401000001FB00000001000F54696D6573204E657720526F6D616EC0D40100000000000000000090">
    <PARAM NAME="Part11" VALUE="010000010300000002000000FFFFFFFFFFFFFFFF0001000000D8020000017D00000001000F54696D6573204E657720526F6D616EC0D401000000000000000000">
    <PARAM NAME="Part12" VALUE="9001000000010100010000000002000000FFFFFF0000000000000100000000000000000002000000FFFFFFFFFFFFFFFF000100000020000000014500000001A8">
    <PARAM NAME="Part13" VALUE="02000001B100000001000000003200000000FFFFFFFFFFFF000002000000000000000000010100030001000000000000000000010000000000000000E0604000">
    <PARAM NAME="Part14" VALUE="00000000000000000000000100FFFFFFFFFFFFFFFF0001000000110000000113000000011E000000010A00000001000300000000000000000000F03F01000000">
    <PARAM NAME="Part15" VALUE="000000144001000000000000E03F01000000000000164001000000000000F03F01000000000000E03F010000000001000000000100000000000000E03F010000">
    <PARAM NAME="Part16" VALUE="00000000F03F010400000000000100000001020000000000010000000200010225620004000000000020A8E140000F54696D6573204E657720526F6D616EC0D4">
    <PARAM NAME="Part17" VALUE="01000000000000000000900100000100000100000000000000000003000100000000000000000000000000000000000000002040010000000000003940010000">
    <PARAM NAME="Part18" VALUE="000000000000010000000000003E4001000000000000244001000000000000144001000000000100000000010000000000000000000100000000000024400104">
    <PARAM NAME="Part19" VALUE="0000000000010000000102000000000001000000020001000000000080564001000F54696D6573204E657720526F6D616EC0D401000000000000000000900100">
    <PARAM NAME="Part20" VALUE="000100000100000000000000000000000100000000000000A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85F3CCE17F01A0C8EB85">
    <PARAM NAME="Part21" VALUE="F3CCE17F01A0C8EB85F3CCE17F01000000000100000000010002000000000001000000020001000000000080564001000F54696D6573204E657720526F6D616E">
    <PARAM NAME="Part22" VALUE="C0D40100000000000000000090010000010000010000000000000000000000010000000000000000000000000000000000000200000005000000000001000000">
    <PARAM NAME="Part23" VALUE="01000000010000000100000000000000000000000000000000000000010000000001010005000000000001000000010000000100000001000000000000000000">
    <PARAM NAME="Part24" VALUE="00000000000000000000010000000001020001010000000001000000000000001440000000000000344000010100010001">
  </OBJECT>
  -->

  <%
    Dim Chart2D2
    Set Chart2D2 = Server.CreateObject("C1Chart2D8.ASPComponent")

    Sub Chart2D2_Load()
      With Chart2D2
        .Width = 600
        .Height = 205
        .IsBatched = True

        With .ChartArea
          With .Axes("X")
            .AnnotationMethod = oc2dAnnotateTimeLabels
            .TimeScale.Unit = oc2dTimeDays
            .TimeScale.Base = 36161
            .TimeScale.Format.Value = "%b"
            Call DemoInitFont(.Font,12,False)
          End With

          Call DemoInitFont(.Axes("Y").Font,12,False)
          Call DemoInitFont(.Axes("Y2").Font,12,False)
        End With

        With .Header
          .Border.Type = oc2dBorderEtchedIn
          Call DemoInitFont(.Font,12,False)
          .Text.Text = "Daily Volumes" & Chr(13) & Chr(10) & "('000s)"
        End With
        Call DemoInitFont(.Footer.Font,12,False)
        Call DemoInitFont(.Legend.Font,12,False)

        .ChartGroups(1).ChartType = oc2dTypeBar
        .IsBatched = False
      End With
    End Sub 

    Call Chart2D2_Load()

  %>

  <!--METADATA TYPE="DesignerControl" endspan-->

  <%
    With Chart2D1
      Call .ChartGroups(1).Data.Load(Server.MapPath("stock_hilo.dat"))
      Call .ChartGroups(2).Data.Load(Server.MapPath("stock_plot.dat"))
    End With
  %>

  <table align=center border=1 cellpadding=1 cellspacing=1 width=75% bgcolor=white>
    <tr>
      <td align=center>Last</td>
      <td align=center>High</td>
      <td align=center>Low</td>
      <td align=center>Volume</td>
    </tr>
    <tr>
      <td align=center>
        <%
          With Chart2D1.ChartGroups(1).Data
            Response.Write(.Y(4,.NumPoints(4)))
          End With
        %>
      </td>
      <td align=center><% Response.Write(Chart2D1.ChartArea.Axes("Y").DataMax) %></td>
      <td align=center><% Response.Write(Chart2D1.ChartArea.Axes("Y").DataMin) %></td>
      <td align=center>3,290,000</td>
    </tr>
  </table>

  <form action="stocks.asp" method="post" id=form1 name=form1>
    <table align=center border=0 cellpadding=10 width=80% bgcolor=white>
      <tr align=left>
        <td>Time period: <%gen_timeframe_selector("timeframe")%></td>
      </tr>
      <tr align=left>
        <td>Compare to this index: <%gen_exchange_selector("Exchange")%></td>
      </tr>
    </table>
    <table align=center border=0 cellpadding=1 cellspacing=1 width=80% bgcolor=white>
      <tr align=center>
        <td>
          <br><br>
          Please click <input type="submit" name="B1" value="Submit"> to see the changes 
          reflected in the charts. 
        </td>
      </tr>
    </table>
  </form>

  <%
    With Chart2D1
      .ChartArea.Axes("Y2").Multiplier = 1
      With Chart2D1.ChartGroups(2)
        .Styles(1).Symbol.Shape = oc2dShapeNone
        .Styles(2).Symbol.Shape = oc2dShapeNone
        .Styles(3).Symbol.Shape = oc2dShapeNone
      End With

      ' Set up the split label
      With .ChartLabels.Add
        .AttachMethod = oc2dAttachDataIndex
        .Name = "split"
        .Text.Text = "2:1 stock" + vbCrLf + "split"
        .IsConnected = True
        .Offset = 10
        .Anchor = oc2dAnchorEast
        .AttachDataIndex.Point = 485
        .Border = oc2dBorderPlain
        .Interior.BackgroundColor = ocColorCornsilk
      End With

      ' Turn on the axis grid
      With .ChartArea
        .Axes("X").MajorGrid.Spacing.IsDefault = True
        .Axes("Y").MajorGrid.Spacing.IsDefault = True
      End With

      ' Make the hilo ticks as small as possible
      .ChartGroups(1).Styles(1).Symbol.Size = 1

      ' Add the series labels
      Call .ChartGroups(1).SeriesLabels.Add("SSFT")

      With .ChartGroups(2).SeriesLabels
        Call .Add("CTSI")
        Call .Add("GSE 500")
        Call .Add("BDIA")
      End With

      ' Move the legend
      With .Legend
        .Anchor = oc2dAnchorSouth
        .Orientation = oc2dOrientHorizontal
      End With

      ' Show visible indices, hide the others
      With Chart2D1.ChartGroups(2).Data
        If Request.Form("Exchange") = "CTSI" Then 
          .SeriesDisplay(1) = oc2dDisplayShow
          .SeriesDisplay(2) = oc2dDisplayHide
          .SeriesDisplay(3) = oc2dDisplayHide
        ElseIf Request.Form("Exchange") = "GSE" then 
          .SeriesDisplay(1) = oc2dDisplayHide
          .SeriesDisplay(2) = oc2dDisplayShow
          .SeriesDisplay(3) = oc2dDisplayHide
        ElseIf Request.Form("Exchange") = "BDIA" then 
          .SeriesDisplay(1) = oc2dDisplayHide
          .SeriesDisplay(2) = oc2dDisplayHide
          .SeriesDisplay(3) = oc2dDisplayShow
        Else
          .SeriesDisplay(1) = oc2dDisplayShow
          .SeriesDisplay(2) = oc2dDisplayShow
          .SeriesDisplay(3) = oc2dDisplayShow
        End If
      End With
    End With

    ' Show desired time interval
    Dim c1Axis, c2Axis
    Set c1Axis = Chart2D1.ChartArea.Axes("X")
    Set c2Axis = Chart2D2.ChartArea.Axes("X")
    If Request.Form("timeframe") = "3M" then 
      c1Axis.Min = 609
      c2Axis.Min = 609
    ElseIf Request.Form("timeframe") = "6M" then 
      c1Axis.Min = 547
      c2Axis.Min = 547
    ElseIf Request.Form("timeframe") = "1Y" then 
      c1Axis.Min = 365
      c2Axis.Min = 365
    Else
      c1Axis.Min = 1
      c2Axis.Min = 1
    End If
    Set c1Axis = Nothing
    Set c2Axis = Nothing

    Call DemoSeparator()
  %>

  <p align=center>
    <%
      Dim dispChart
      dispChart = Session("DispChart")
      If dispChart = "Jpeg" Then
        Call OlectraChart2D_GenerateTag_JPEG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png" Then
        Call OlectraChart2D_GenerateTag_PNG(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Png-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D1, "Chart2D1")
      ElseIf dispChart = "Jpeg-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D1, "Chart2D1")
      Else
        Call OlectraChart2D_GenerateTag(Chart2D1, "Chart2D1")
      End If
    %>
  </p>

  <%
    With Chart2D2
      Call .ChartGroups(1).Data.Load(Server.MapPath("stock_vol.dat"))

      With .ChartArea
        ' Turn on the Y2 axis
        .Axes("Y2").Multiplier = 1

        ' Turn off outlines to maximize display space for the bars
        .IsShowingOutlines=False

        ' Turn on the axis grid
        .Axes("X").MajorGrid.Spacing.IsDefault = True
        .Axes("Y").MajorGrid.Spacing.IsDefault = True

        ' Show Y axis data in '000s
        .Axes("Y").LabelFormat.Format = "0,"
        .Axes("Y2").LabelFormat.Format = "0,"
      End With
    End With
  %>

  <p align=center>
    <%
      dispChart = Session("DispChart")
      If dispChart = "Jpeg" Then
        Call OlectraChart2D_GenerateTag_JPEG(Chart2D2, "Chart2D2")
      ElseIf dispChart = "Png" Then
        Call OlectraChart2D_GenerateTag_PNG(Chart2D2, "Chart2D2")
      ElseIf dispChart = "Png-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_PNG_BinaryWrite(Chart2D2, "Chart2D2")
      ElseIf dispChart = "Jpeg-BinaryWrite" Then
        Call OlectraChart2D_GenerateTag_JPEG_BinaryWrite(Chart2D2, "Chart2D2")
      Else
        Call OlectraChart2D_GenerateTag(Chart2D2, "Chart2D2")
      End If
    %>
  </p>


  <%
    Call DemoSeparator()
    Call DemoCopyrightAndSource()

    Set Chart2D1 = Nothing
    Set Chart2d2 = Nothing
  %>

  </body>
</html>
