<%@ Language=JavaScript %>
<!---
//*****************************************************************************
//*
//* Copyright (c) ComponentOne, LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/3dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/3dgentag.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/JavaS/utils.inc" -->

<html>

  <head>
    <title>ComponentOne WebChart 3D - Distribution Ranges Example</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
    var Chart3D1;

    DemoPageHeader();                            // utils.inc
    DemoTitle3D("Distribution Ranges Example");  // utils.inc

    function gen_select_entry(selector, value, label)
    {
      Response.Write("<OPTION value=\"" + value + "\"");
      if(Request.Form(selector) == value)
        Response.Write(" selected");
      Response.Write("> " + label + "\n");
    }

    var CurrentMeshing;
    CurrentMeshing = (Request.Form("Meshing") == "ON");

    var CurrentXGridLines;
    CurrentXGridLines = (Request.Form("XGridLines") == "ON");

    var CurrentYGridLines;
    CurrentYGridLines = (Request.Form("YGridLines") == "ON");

    var CurrentZGridLines;
    CurrentZGridLines = (Request.Form("ZGridLines") == "ON");

    var CurrentLegendFilter;
    if(Request.Form("LegendFilter").Count == 0)
      CurrentLegendFilter = 1;
    else
      CurrentLegendFilter = Request.Form("LegendFilter")(1);
  %>

  <form action="DstRange.asp" method="post" id="form1" name="form1">
    <table border=0 align=center width=90% >
      <tr align=center>
        <td>
          <input id="Meshing" name="Meshing" type="checkbox"
            <% DemoCheckWriter(CurrentMeshing) %> value="ON">
          Meshing? &nbsp;&nbsp;&nbsp;&nbsp;

          Grid Lines:&nbsp;
          <input id="XGridLines" name="XGridLines" type="checkbox"
            <% DemoCheckWriter(CurrentXGridLines) %> value="ON">
          X-Axis &nbsp;&nbsp;

          <input id="YGridLines" name="YGridLines" type="checkbox"
            <% DemoCheckWriter(CurrentYGridLines) %> value="ON">
          Y-Axis &nbsp;&nbsp;

          <input id="ZGridLines" name="ZGridLines" type="checkbox"
            <% DemoCheckWriter(CurrentZGridLines) %> value="ON">
          Z-Axis
        </td>
      </tr>

      <tr align=center>
        <td><br>
          Dataset:
          <%
            Response.Write("<select name=\"Dataset\" size=1>\n");
            gen_select_entry( "Dataset", "1", "Set 1");
            gen_select_entry( "Dataset", "2", "Set 2");
            gen_select_entry( "Dataset", "B", "Both");
            Response.Write("</select>\n");
          %> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

          Distribution Range:
          <%
            Response.Write("<select name=\"DstRange\" size=1>\n");
            gen_select_entry( "DstRange", "DATA", "Data");
            gen_select_entry( "DstRange", "ALL", "All");
            Response.Write("</select>\n");
          %>

        </td>
      </tr>

      <tr align=center>
        <td><br>
          Legend Display:
          <%
            Response.Write("<select name=\"LegendDisplay\" size=1>\n");
            gen_select_entry( "LegendDisplay", "CONT", "Continuous");
            gen_select_entry( "LegendDisplay", "STEP", "Stepped");
            Response.Write("</select>\n");
          %> &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;

          Legend Filter:
          <input id="LegendFilter" name="LegendFilter" value="<%= CurrentLegendFilter %>" SIZE=2>
        </td>
      </tr>

      <tr align=center>
        <td><br><br>
          Please click <input type="submit" name="B1" value="Submit" language="JavaScript" onclick=form1_onsubmit()>
          to see the changes reflected in the chart(s) below:
        </td>
      </tr>
    </table>

    <script language="JavaScript">
      function form1_onsubmit()
      {
        if(document.form1.LegendFilter.value > 10)
          document.form1.LegendFilter.value = "10";
        else if(document.form1.LegendFilter.value < 1)
          document.form1.LegendFilter.value = "1";
      }
    </script>
  </form>

  <!--METADATA TYPE="DesignerControl" startspan
    <OBJECT classid="clsid:A9E797CE-C03D-46E3-B44D-61B8DCEB9849" height=429 
      id=Chart3D1 style="HEIGHT: 429px; LEFT: 0px; TOP: 0px; WIDTH: 480px" width=480>
      <PARAM NAME="PersistenceVersion" VALUE="1">
      <PARAM NAME="Language" VALUE="2">
      <PARAM NAME="TagRoutine" VALUE="">
      <PARAM NAME="ByteCount" VALUE="4124">
      <PARAM NAME="Part0" VALUE="0000060001000B4B4C5F43484152542E33449C310000562C00000000000000000000FFFFFFFF00000000000059400000000000005940000002000000FFFFFFFF">
      <PARAM NAME="Part1" VALUE="FFFFFFFF00010000001100000001450000000152010000013501000001030000000005417269616C444201000000000000000000900100000D005A000000000D">
      <PARAM NAME="Part2" VALUE="4D532053616E73205365726966444201000000000000000000900100000D005000000000894160E5D022F93F01884160E5D022094001000000000200FF7F5000">
      <PARAM NAME="Part3" VALUE="0100000003000101000005417269616C444201000000000000000000900100000D005A000000000D4D532053616E732053657269664442010000000000000000">
      <PARAM NAME="Part4" VALUE="00900100000D005000000000894160E5D022F93F01884160E5D022094001000000000200FF7F50000100000005000101000005417269616C4442010000000000">
      <PARAM NAME="Part5" VALUE="00000000900100000D005A000000000D4D532053616E73205365726966444201000000000000000000900100000D00500000000065A88AA9F413C43F0144DD07">
      <PARAM NAME="Part6" VALUE="20B589FB3F01000000000200FF7F5000010000000600010100000000000000000000000000000000000000000000005440000000000000544000010101000000">
      <PARAM NAME="Part7" VALUE="0100000001000000000000F03F000000000000000000000000000000000000000000000440000000000080464000000000000000000000000000804640000002">
      <PARAM NAME="Part8" VALUE="0000002F4F4F00FFEBCD0000010000000100000001000001001400000014000000A0C8EB85F3CCE17FB6291BDCCA2AB53FB6291BDCCA2AB53F894160E5D022F9">
      <PARAM NAME="Part9" VALUE="3F894160E5D022F93F2B137EA99F37F53F8AB0E1E995B2F63F753C66A032FEF73F2046088F360EF93F9C6D6E4C4FD8F93FF6622827DA55FA3FDB5031CEDF84FA">
      <PARAM NAME="Part10" VALUE="3FB8239C16BC68FA3F43C5387F130AFA3F67EDB60BCD75F93F406A1327F7BBF83F3CF71E2E39EEF73F75029A081B1EF73F79060DFD135CF63FF584251E50B6F5">
      <PARAM NAME="Part11" VALUE="3FD595CFF23C38F53F984C158C4AEAF43F52B81E85EBD1F43FA8E3310395F1F43F2922C32ADE48F53F897B2C7DE882F53FCA89761552FEF63FC286A757CA32F8">
      <PARAM NAME="Part12" VALUE="3F137EA99F3715F93F3BE466B8019FF93FACADD85F76CFF93FEA95B20C71ACF93FC425C79DD241F93F38842A357BA0F83FCE531D7233DCF73F7DB3CD8DE909F7">
      <PARAM NAME="Part13" VALUE="3F3DF20703CF3DF63F2766BD18CA89F53F9413ED2AA4FCF43FC47762D68BA1F43FABB2EF8AE07FF43F08E6E8F17B9BF43FBF9A030473F4F43F65E42CEC6987F5">
      <PARAM NAME="Part14" VALUE="3F21020EA14A4DF63F7B319413EDAAF53F8B1A4CC3F011F73F9869FB57561AF83F936FB6B931BDF83F26C79DD2C1FAF83F4260E5D022DBF83F9274CDE49B6DF8">
      <PARAM NAME="Part15" VALUE="3FBBD573D2FBC6F73F57957D5704FFF63FAE47E17A142EF63FD00A0C59DD6AF53F9BE61DA7E8C8F43FD68BA19C6857F43F37548CF33721F43FB1A71DFE9A2CF4">
      <PARAM NAME="Part16" VALUE="3F410E4A98697BF43FEC2FBB270F0BF53FA25D85949FD4F53F787FBC57ADCCF63F6C26DF6C73E3F73F8EE9094B3CA0F53F745E6397A8DEF63F7D7901F6D1A9F7">
      <PARAM NAME="Part17" VALUE="3F6E3480B74002F83FA7CB6262F3F1F73F97CADB114E8BF73FD7FA22A12DE7F63FE1EEACDD7621F63FD8D30E7F4D56F53F9031772D219FF43FA9C1340C1F11F4">
      <PARAM NAME="Part18" VALUE="3F5CC98E8D40BCF33F7B319413EDAAF33FA75CE15D2EE2F33FC4EBFA05BB61F43F6B82A8FB0024F53F20B58993FB1DF63F1E1B81785D3FF73FC2FA3F87F972F8">
      <PARAM NAME="Part19" VALUE="3F728A8EE4F29FF93F12C2A38D2356F53FEC12D55B035BF63F03B2D7BB3FDEF63F5F46B1DCD2EAF63F841266DAFE95F63FCD0182397AFCF53F910F7A36AB3EF5">
      <PARAM NAME="Part20" VALUE="3F06D847A7AE7CF43F884677103BD3F33FD2FBC6D79E59F33F715AF0A2AF20F33F6D3997E2AA32F33F16F6B4C35F93F33FC68503215940F43FA99F3715A930F5">
      <PARAM NAME="Part21" VALUE="3FDB334B02D454F63F9E29745E6397F73F76A6D0798DDDF83F44DD0720B509FA3F58AD4CF8A5FEFA3FF86BB2463DC4F43FDC80CF0F2384F53F936FB6B931BDF5">
      <PARAM NAME="Part22" VALUE="3F11C7BAB88D86F53FAA8251499D00F53F718FA50F5D50F43FD13FC1C58A9AF33F72DC291DACFFF23FEFE6A90EB999F23F7B14AE47E17AF23F5A12A0A696ADF2">
      <PARAM NAME="Part23" VALUE="3F31D3F6AFAC34F33F088F368E580BF43FBE874B8E3B25F53F1F80D4264E6EF63F7AC7293A92CBF73FB0389CF9D51CF93FE3FC4D284440FA3F49F4328AE516FB">
      <PARAM NAME="Part24" VALUE="3F44DD0720B589FB3FF3599E0777E7F33FE73A8DB4545EF43F6B9F8EC70C54F43FCEC29E76F8EBF33FE4839ECDAA4FF33F9B20EA3E00A9F23F5BD3BCE3141DF2">
      <PARAM NAME="Part25" VALUE="3F9ACE4E0647C9F13F1973D712F2C1F13FC3F011312512F23FB22E6EA301BCF23F9B8F6B43C5B8F33F2A5778978BF8F43F8ACDC7B5A162F63F9FE5797077D6F7">
      <PARAM NAME="Part26" VALUE="3F58CA32C4B12EF93FD9942BBCCB45FA3F2367614F3BFCFA3FE78C28ED0D3EFB3F9ED2C1FA3F07FB3FC3F5285C8FC2F23FBF9A030473F4F23FBCAE5FB01BB6F2">
      <PARAM NAME="Part27" VALUE="3FDA5548F94935F23FA818E76F42A1F13F86C954C1A824F13FFEF15EB532E1F03F3CF71E2E39EEF03F47205ED72F58F13FE2067C7E1821F23F1CD313967840F3">
      <PARAM NAME="Part28" VALUE="3FDE76A1B94EA3F43FCE3637A6272CF63FA27F828B15B5F73F4FCC7A319413F93FC91F0C3CF71EFA3FBA4E232D95B7FA3FAF25E4839ECDFA3F6ADE718A8E64FA">
      <PARAM NAME="Part29" VALUE="3F349D9D0C8E92F93F2041F163CC5DF13F66F7E461A156F13F60CD018239FAF03FAF5A99F04B7DF03F548CF337A110F03F6519E25817B7EF3F8FA7E507AEF2EF">
      <PARAM NAME="Part30" VALUE="3FB77A4E7ADF78F03F77D66EBBD05CF13FCFF753E3A59BF23F1D554D10751FF43FD8648D7A88C6F53F1349F4328A65F73F221ADD41ECCCF83FFFB27BF2B0D0F9">
      <PARAM NAME="Part31" VALUE="3F6F47382D7851FA3FC1ADBB79AA43FA3F51DA1B7C61B2F93FE9D495CFF2BCF83F1CCEFC6A0E90F73F56293DD34B8CEF3F43C9E4D4CE30EF3F4AF086342A70EE">
      <PARAM NAME="Part32" VALUE="3FB16B7BBB25B9ED3FE753C72AA567ED3F2DB1321AF9BCED3F48A643A7E7DDEE3F28B858518369F03FA306D3307CC4F13FF241CF66D567F33FE7357689EA2DF5">
      <PARAM NAME="Part33" VALUE="3F2E90A0F831E6F63FEBE2361AC05BF83F57CF49EF1B5FF93F1B2AC6F99BD0F93FB8AF03E78CA8F93F0CB08F4E5DF9F83FB493C151F2EAF73FA857CA32C4B1F6">
      <PARAM NAME="Part34" VALUE="3F156F641EF983F53FA8FFACF9F117EC3F21E527D53E9DEB3F959A3DD00A0CEB3F73D712F241CFEA3F249D81919735EB3F04392861A66DEC3F40DF162CD585EE">
      <PARAM NAME="Part35" VALUE="3F83C0CAA145B6F03F48FE60E0B977F23FE73A8DB4545EF43FDB85E63A8D34F63F7250C24CDBBFF73FEA5BE67459CCF83F7E00529B3839F93F367689EAAD01F9">
      <PARAM NAME="Part36" VALUE="3F3BC269C18B3EF83F8E01D9EBDD1FF73FE17A14AE47E1F53F5969520ABABDF43FD942908312E6F33F124C35B39682E83FA8AAD0402C1BE83FEBFCDB65BFEEE7">
      <PARAM NAME="Part37" VALUE="3FAC71361D015CE83FBF49D3A0689EE93FBB438A0112CDEB3F53E9279CDDDAEE3F7BF7C77BD54AF13F33E197FA7953F33FCCB4FD2B2B4DF53FD751D50451F7F6">
      <PARAM NAME="Part38" VALUE="3F9CE1067C7E18F83FB0C91AF5108DF83F53D0ED258D51F83F6ABC74931884F73F5C8FC2F5285CF63F2315C616821CF53F4D158C4AEA04F43FB98D06F01648F3">
      <PARAM NAME="Part39" VALUE="3F2C0E677E3507F33FCC0D863AACF0E43F3B014D840DCFE43F27C0B0FCF936E53F109546CCEC73E63F295C8FC2F5A8E83F93718C648FD0EB3F357C0BEBC6BBEF">
      <PARAM NAME="Part40" VALUE="3F450DA661F808F23FCF66D5E76A2BF43F58C51B9947FEF53F53910A630B41F73F975643E21ECBF73F2B357BA01598F73FD28C45D3D9C9F63F3BFC3559A39EF5">
      <PARAM NAME="Part41" VALUE="3F5587DC0C3760F43FC0046EDDCD53F33FC98E8D40BCAEF23F1956F146E691F23F9A42E7357609F33FBA86191A4F84E13F20EBA9D557D7E13FE2EA0088BBFAE2">
      <PARAM NAME="Part42" VALUE="3F2C6684B70721E53FDE0033DFC14FE83F081D7409875EEC3F5E9D6340F67AF03F999EB0C403CAF23FACC5A70018CFF43FA9DE1AD82A41F63F00A94D9CDCEFF6">
      <PARAM NAME="Part43" VALUE="3FC2340C1F11D3F63FCBF8F719170EF63FF701486DE2E4F43FF085C954C1A8F33F693A3B191CA5F23F3485CE6BEC12F23F4EB4AB90F213F23F8AC8B08A37B2F2">
      <PARAM NAME="Part44" VALUE="3F381092054CE0F33F225514AFB2B6DC3F1C0C7558E196DE3F2194F7713447E13FB69DB6460463E43F2635B401D880E83F64963D096C4EED3FC0E78711C223F1">
      <PARAM NAME="Part45" VALUE="3FA52C431CEB62F33FA79196CADB11F53FDAC9E02879F5F53F20EF552B13FEF53FCB9C2E8B894DF53FCE3637A6272CF43F89247A19C5F2F23FF888981249F4F1">
      <PARAM NAME="Part46" VALUE="3F573ECBF3E06EF13FBC79AA436E86F13F4ED1915CFE43F23F679B1BD31396F33FE353008C6750F53F12A452EC681CD73F21C9ACDEE176DA3F32E9EFA5F020E0">
      <PARAM NAME="Part47" VALUE="3FC3F352B1312FE43F98141F9F901DE93F7CED9925016AEE3F6D3997E2AAB2F13F7B4963B48EAAF33F32C9C859D8D3F43FC2C073EFE112F53FC02154A9D983F4">
      <PARAM NAME="Part48" VALUE="3FA9FB00A43671F33F252367614F3BF23F923F1878EE3DF13F912749D74CBEF03FDCBA9BA73AE4F03F0C3CF71E2EB9F13F624A24D1CB28F33F543541D47D00F5">
      <PARAM NAME="Part49" VALUE="3F1990BDDEFDF1F63F4DF910548D5ED23FAAD4EC815660D73FDB1324B6BB07DF3F7155D9774570E43FB3EA73B515FBE93FE2E995B20C71EF3F355EBA490C02F2">
      <PARAM NAME="Part50" VALUE="3F8CF337A11081F33F29965B5A0D09F43F97900F7A36ABF33FC616821C94B0F23FC7116BF12980F13F8E3BA583F57FF03F2D25CB4928FDEF3FEE3D5C72DC29F0">
      <PARAM NAME="Part51" VALUE="3FCB10C7BAB80DF13F14AE47E17A94F23F2D3E05C07886F43F3EEDF0D7648DF63F1973D712F241F83F1F317A6EA12BCD3F99620E828E56D53F44BE4BA94BC6DE">
      <PARAM NAME="Part52" VALUE="3F06D9B27C5D06E53FE12538F581E4EA3FAB09A2EE0310F03FC32ADEC83CF2F13F11AAD4EC81D6F23F23DBF97E6ABCF23F2E90A0F831E6F13FE42CEC6987BFF0">
      <PARAM NAME="Part53" VALUE="3F44300E2E1D73EF3F5FB2F1608B5DEE3F699082A790ABEE3FC8CD70033E3FF03FF54A598638D6F13FC763062AE3DFF33F3B3602F1BAFEF53FA67EDE54A4C2F7">
      <PARAM NAME="Part54" VALUE="3F82E7DEC325C7F83F87A3AB74779DC73F1FBAA0BE654ED43FBEF90D130D52DF3FBF1072DEFFC7E53F5CC64D0D349FEB3FCDAFE600C11CF03F01C11C3D7E6FF1">
      <PARAM NAME="Part55" VALUE="3F75594C6C3EAEF13F3E05C078060DF13FD943FB58C1EFEF3FD350A39064D6ED3F2EC6C03A8E9FEC3F38A1100187D0EC3F9981CAF8F799EE3FCEAACFD556ECF0">
      <PARAM NAME="Part56" VALUE="3F43AD69DE710AF33F6A300DC34744F53F8DD13AAA9A20F73F8AC8B08A3732F83FFF5BC98E8D40F83F65A88AA9F413C43FE1B20A9B012ED43F0A4966F50E37E0">
      <PARAM NAME="Part57" VALUE="3FC57421567F84E63F0FBA84436FF1EB3F8927BB99D18FEF3FD9B11188D775F03FE6AE25E4831EF03FCFBF5DF6EB4EEE3F3FE3C281902CEC3F2A3A92CB7FC8EA">
      <PARAM NAME="Part58" VALUE="3F5FED28CE51C7EA3F7D5BB0541770EC3F9AB33EE598ACEF3FA3923A014D04F23F41481630815BF43F990D32C9C859F63F10AFEB17EC86F73F894160E5D0A2F7">
      <PARAM NAME="Part59" VALUE="3F8B4F01309EC1F63F01000001000000000000000000A0C8EB85F3CCE17F00000000000000000000000000000000000000000000000000000000000000000101">
      <PARAM NAME="Part60" VALUE="000000000000000000D3D3D30070707000000A0000000100000000010100000000000000000000010000000200FF7F50000100000002000000CD000700000000">
      <PARAM NAME="Part61" VALUE="00090004000000FFFFFFFFFFFFFFFF00010000006400000001120000000112446973747269627574696F6E2052616E67650005417269616CA42C020000000000">
      <PARAM NAME="Part62" VALUE="0000000090010000010300090002000000FFFFFFFFFFFFFFFF00010000009F00000001870100000107446174617365740005417269616CDC7C01000000000000">
      <PARAM NAME="Part63" VALUE="00000090010000010300030004000000FFFFFFFFFF7F5000000100000072010000016D00000001000000000005417269616C4442010000000000000000009001">
      <PARAM NAME="Part64" VALUE="00000552616E67650101000100020001000100000000000100000101">
    </OBJECT>
  -->

  <%
    Chart3D1 = Server.CreateObject("C1Chart3D8.ASPComponent");

    function Chart3D1_Load()
    {
      with(Chart3D1)
      {
        Width = 480;
        Height = 429;
        IsBatched = true;
        UseTrueType = true;

        with(ChartGroups(1))
        {
          with(Contour)
          {
            IsContoured = true;
            IsZoned = true;
          }
          Elevation.IsShaded = true;
        }

        with(ChartArea)
        {
          with(Axes("X"))
          {
            MajorGrid.IsOnXYPlane = true;
            MajorGrid.IsOnXZPlane = true;
            MajorGrid.Style.Color = 5275647;

            DemoInitFont(TitleFont.TrueType,8.25,false);

            AnnotationFont.Size = 90;
            DemoInitFont(AnnotationFont.TrueType,8.25,false);
          }

          with(Axes("Y"))
          {
            MajorGrid.IsOnXYPlane = true;
            MajorGrid.IsOnYZPlane = true;
            MajorGrid.Style.Color = 5275647;

            DemoInitFont(TitleFont.TrueType,12,false);

            AnnotationFont.Size = 90;
            DemoInitFont(AnnotationFont.TrueType,12,false);
          }

          with(Axes("Z"))
          {
            MajorGrid.IsOnXZPlane = true;
            MajorGrid.IsOnYZPlane = true;
            MajorGrid.Style.Color = 5275647;

            DemoInitFont(TitleFont.TrueType,12,false);
            AnnotationFont.Size = 90;
            DemoInitFont(AnnotationFont.TrueType,12,false);
          }
        }

        with(Header)
        {
          with(Border)
          {
            Type = oc3dBorderBevel;
            Width = 4;
          }
          DemoInitFont(Font,14.25,false);
          Text.Text = "Distribution Range";
        }
        
        with(Footer)
        {
          Border.Type = oc3dBorderBevel;
          DemoInitFont(Font,9.75,false);
          Text.Text = "Dataset";
        }
        
        with(Legend)
        {
          with(Border)
          {
            Type = oc3dBorderShadow;
            Width = 4;
          }
          DemoInitFont(Font,8.25,false);
          Interior.ForegroundColor = 5275647;
          Text.Text = "Range";
        }
        
        with(Interior)
        {
          ForegroundColor = 13495295;
          BackgroundColor = 5197615;
        }
        
        IsBatched = false;
      }
    } 

    Chart3D1_Load();
  %>

  <!--METADATA TYPE="DesignerControl" endspan -->

  <%
    with(Chart3D1)
    {
      // Meshing
      ChartGroups(1).Elevation.IsMeshed = CurrentMeshing;

      // Grid lines
      with(ChartArea)
      {
        with(Axes("X"))
        {
          MajorGrid.IsOnXYPlane = CurrentXGridLines;
          MajorGrid.IsOnXZPlane = CurrentXGridLines;
        }

        with(Axes("Y"))
        {
          MajorGrid.IsOnXYPlane = CurrentYGridLines;
          MajorGrid.IsOnYZPlane = CurrentYGridLines;
        }

        with(Axes("Z"))
        {
          MajorGrid.IsOnXZPlane = CurrentZGridLines;
          MajorGrid.IsOnYZPlane = CurrentZGridLines;
        }
      }

      with(Legend)
      {
        //Distribution Range
        if(Request.Form("DstRange") == "ALL")
          DistributionRange = oc3dDistributionRangeAll;
        else
          // Data is the default behavior
          DistributionRange = oc3dDistributionRangeData;

        //Legend display
        if(Request.Form("LegendDisplay") == "STEP")
          Type = oc3dLegendTypeStepped;
        else
          // Continuous is the default behavior
          Type = oc3dLegendTypeContinuous;

        //Legend Label Filter (onsubmit check keeps it in a valid range)
        if(Request.Form("LegendFilter").Count == 0)
          CurrentLegendFilter = 1;
        else
          CurrentLegendFilter = Request.Form("LegendFilter")(1);

        LabelFilter = CurrentLegendFilter;
      }

      // Load the custom levels data
      ChartGroups(1).Contour.Levels.Load(Server.MapPath("levels.lvl"));

      var dispChart;

      //Choose dataset and generate chart(s) .. we force JPEG ouput for this example
      if( (Request.Form("Dataset") == "1") || (Request.Form("Dataset") == "B") || (Request.Form("Dataset").Count == 0) )
      {
        ChartGroups(1).ElevationData.Load(Server.MapPath("dstrng1.dat"));
        Footer.Text = "Dataset 1";
        Response.Write("<p align=center>");

        dispChart = Session("DispChart");
        if(dispChart == "Jpeg")
          OlectraChart3D_GenerateTag_JPEG(Chart3D1, "Chart3D1");
        else if(dispChart == "Png")
          OlectraChart3D_GenerateTag_PNG(Chart3D1, "Chart3D1");
        else if(dispChart == "Png-BinaryWrite")
          OlectraChart3D_GenerateTag_PNG_BinaryWrite(Chart3D1, "Chart3D1");
        else if(dispChart == "Jpeg-BinaryWrite")
          OlectraChart3D_GenerateTag_JPEG_BinaryWrite(Chart3D1, "Chart3D1");
        else
          OlectraChart3D_GenerateTag(Chart3D1, "Chart3D1");

        Response.Write("</p>");
      }

      if(Request.Form("Dataset") == "B")
        Response.Write("<br><br>");

      if( (Request.Form("Dataset") == "2") || (Request.Form("Dataset") == "B") )
      {
        ChartGroups(1).ElevationData.Load(Server.MapPath("dstrng2.dat"));
        Footer.Text = "Dataset 2";
        Response.Write("<p align=center>");

        dispChart = Session("DispChart");
        if(dispChart == "Jpeg")
          OlectraChart3D_GenerateTag_JPEG(Chart3D1, "Chart3D1");
        else if(dispChart == "Png")
          OlectraChart3D_GenerateTag_PNG(Chart3D1, "Chart3D1");
        else if(dispChart == "Png-BinaryWrite")
          OlectraChart3D_GenerateTag_PNG_BinaryWrite(Chart3D1, "Chart3D1");
        else if(dispChart == "Jpeg-BinaryWrite")
          OlectraChart3D_GenerateTag_JPEG_BinaryWrite(Chart3D1, "Chart3D1");
        else
          OlectraChart3D_GenerateTag(Chart3D1, "Chart3D1");

        Response.Write("</p>");
      }
    }
  %>

  <table border=0 align=center width=90% >
    <tr>
      <td>
        This example shows:
        <ul>
          <li>How to set the DistributionRange property to control the number of levels in the legend </li>
          <li>How to use the LabelFilter property of the Legend object to show a specific number of
              levels </li>
          <li>How to show the legend as either Stepped or Continuous </font></li>
        </ul>
      </td>
    </tr>
  </table>

  <%
    DemoSeparator();
    DemoCopyrightAndSource();

    Chart3D1 = 0;
  %>

  </body>
</html>
