<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/color.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/3dconst.inc" -->
<!-- #INCLUDE VIRTUAL="/WebChart8/Include/VBS/utils.inc" -->

  <head>
    <title>ComponentOne WebChart 3D - Binary Streaming Example</title>
  </head>

  <body link="#003399" vlink="#cc0000" bgcolor="#ffffff">

  <%
      Sub gen_source()
        Response.Write("SRC=""" & "genimage.asp")
        Response.Write("?Quality=" & ImageQuality)
        Response.Write("&ChartType=" & Request.Form("ChartType"))
        Response.Write("&FColor=" & Request.Form("FColor"))
        Response.Write("&BColor=" & Request.Form("BColor"))

        If CurrentGrayscale Then 
          Response.Write("&Grayscale=T")
        End If

        Response.Write("""")
      End Sub

      Private Sub gen_select_entry(selector, value, label)
        Response.Write("<OPTION value=""" & value & """")
        If Request.Form(selector) = value Then 
          Response.Write("selected")
        End If
        Response.Write("> " & label & Chr(10))
      End Sub

      Private Sub gen_selector(selector)
        Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
        call gen_select_entry( selector, "SURF", "Surface")
        call gen_select_entry( selector, "BAR", "Bar")
        call gen_select_entry( selector, "SCAT", "Scatter")
        Response.Write("</select>")
      End Sub

      Private Sub gen_forecolor_selector(selector)
        Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
        call gen_select_entry( selector, "BLACK", "Black")
        call gen_select_entry( selector, "BLUE", "Blue")
        call gen_select_entry( selector, "DARKGREEN", "DarkGreen")
        call gen_select_entry( selector, "RED", "Red")
        Response.Write("</select>")
      End Sub

      Private Sub gen_backcolor_selector(selector)
        Response.Write("<select name=""" & selector & """ size=""1"">" & Chr(10))
        call gen_select_entry( selector, "WHITE", "White")
        call gen_select_entry( selector, "LIGHTBLUE", "LightBlue")
        call gen_select_entry( selector, "LIGHTSEAGREEN", "LightSeaGreen")
        call gen_select_entry( selector, "MISTYROSE", "MistyRose")
        Response.Write("</select>")
      End Sub

    'Set up the page headers and titles
      Call DemoPageHeader                     ' utils.inc
      Call DemoTitle3D("Binary Streaming Example")  ' utils.inc

      Dim CurrentGrayscale, ImageQuality

      CurrentGrayscale = (Request.Form("Grayscale") = "ON")

      If Request.Form("text1").Count = 0 Then
        ImageQuality = 85
      Else
        ImageQuality = Request.Form("text1")
      End If
  %>

  <form action="BinStream.asp" method="Post" id="form1" name="form1">
    <p>
      <table border=0 align=center width=80% >
        <tr align=center>
          <td>
            Chart Type: <%gen_selector("ChartType")%>
          </td>
          <td>
            Foreground color: <%gen_forecolor_selector("FColor")%>
          </td>
          <td>
            Background color: <%gen_backcolor_selector("BColor")%>
          </td>
        </tr>
      </table>
    </p>

    <p>
      <table border=0 align=center width=60% >
        <tr align=center>
          <td>
            Jpeg Image Options:
          </td>
          <td>
            ImageQuality (0 to 100):
            <input id=text1 name="text1" value="<%= ImageQuality %>" size=2>
          </td>
          <td>
            <input id="Grayscale" name="Grayscale" type="checkbox"
              <% DemoCheckWriter(CurrentGrayscale) %> value="ON">
            Grayscale?
          </td>
        </tr>
      </table>
    </p>

    <p>
      <table border=0 align=center width=80% >
        <tr align=center>
          <td>
            Please click <input type="submit" name="B1" value="Submit">
            to see the changes reflected in the chart below:
          </td>
        </tr>
      </table>
    </p>
  </form>

<%  Call DemoSeparator()                              ' utils.inc %>

  <p align="center">
    <IMG ID="CHART3D" NAME="CHART3D" <%gen_source()%> >
  </p>

  <p align=left width=90% >
    <font face="Arial"><table align=center width=90% ><tbody><tr><td>
      This example shows how to generate chart image without using temporary files and
      session variables. The chart image is generated by another auxilary page
      genimage.asp(<a target=_blank href="/WebChart8/srcview.asp?fn=/WebChart8/3D/demos/vbs/genimage.asp&stype=vbs">view source</a>).
    </td></tr></tbody></table></font>
  </p>

  <p align="center">
    <%
      Call DemoSeparator()                              ' utils.inc
      Call DemoCopyrightAndSource()                     ' utils.inc
    %>
  </p>

  </body>
</html>
