<%
//*****************************************************************************
//*
//* Copyright (c) ComponentOne LLC.
//* Portions Copyright (c) 1999, KL GROUP INC.
//* http://www.componentone.com
//*
//* This file is provided for demonstration and educational uses only.
//* Permission to use, copy, modify and distribute this file for
//* any purpose and without fee is hereby granted, provided that the
//* above copyright notice and this permission notice appear in all
//* copies, and that the name of ComponentOne not be used in advertising
//* or publicity pertaining to this material without the specific,
//* prior written permission of an authorized representative of
//* ComponentOne.
//*
//* COMPONENTONE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
//* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
//* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
//* PURPOSE, OR NON-INFRINGEMENT. COMPONENTONE SHALL NOT BE LIABLE FOR ANY
//* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
//* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
//*
//*****************************************************************************

//This file contains a list of colors that can be used
// in any JavaScript program.  These colors can also be found in
// the property pages of the Olectra Chart controls.

//The HEX values can also be broken down into their
// Red Green Blue (RGB) equivalents by breaking the number
// down by pairs of digits.  Here is an example:
//    ocColorTurquoise = 0xD0E040
//    Blue = 0xD0 (208), Green = 0xE0 (224), Red = 0x40 (64)
//
// Note that the order of RGB is from least significant to
// most significant. i.e 0xBBGGRR
//

//ocDefaultColor is the same as "(Automatic)" in the property pages
var ocDefaultColor = 0xFFFFFFFF;

var ocColorAliceBlue = 0xFFF8F0;
var ocColorAntiqueWhite = 0xD7EBFA;
var ocColorAquamarine = 0xD4FF7F;
var ocColorAzure = 0xFFFFF0;
var ocColorBeige = 0xDCF5F5;
var ocColorBisque = 0xC4E4FF;
var ocColorBlack = 0x0;
var ocColorBlanchedAlmond = 0xCDEBFF;
var ocColorBlue = 0xFF0000;
var ocColorBlueViolet = 0xE22B8A;
var ocColorBrown = 0x2A2AA5;
var ocColorBurlywood = 0x87B8DE;
var ocColorCadetBlue = 0xA09E5F;
var ocColorChartreuse = 0x00FF7F;
var ocColorChocolate = 0x1E69D2;
var ocColorCoral = 0x507FFF;
var ocColorCornflowerBlue = 0xED9564;
var ocColorCornsilk = 0xDCF8FF;
var ocColorCyan = 0xFFFF00;
var ocColorDarkGoldenrod = 0xB86B8;
var ocColorDarkGreen = 0x006400;
var ocColorDarkKhaki = 0x6BB7BD;
var ocColorDarkOliveGreen = 0x2F6B55;
var ocColorDarkOrange = 0x8CFF;
var ocColorDarkOrchid = 0xCC3299;
var ocColorDarkSalmon = 0x7A96E9;
var ocColorDarkSeaGreen = 0x8FBC8F;
var ocColorDarkSlateBlue = 0x8B3D48;
var ocColorDarkSlateGray = 0x4F4F2F;
var ocColorDarkTurquoise = 0xD1CE00;
var ocColorDarkViolet = 0xD30094;
var ocColorDeepPink = 0x9314FF;
var ocColorDeepSkyBlue = 0xFFBF00;
var ocColorDodgerBlue = 0xFF901E;
var ocColorFirebrick = 0x2222B2;
var ocColorFloralWhite = 0xF0FAFF;
var ocColorForestGreen = 0x228B22;
var ocColorGainsboro = 0xDCDCDC;
var ocColorGhostWhite = 0xFFF8F8;
var ocColorGold = 0x00D7FF;
var ocColorGoldenrod = 0x20A5DA;
var ocColorGray = 0xBEBEBE;
var ocColorGray0 = 0x0;
var ocColorGray1 = 0x30303;
var ocColorGray2 = 0x50505;
var ocColorGray3 = 0x80808;
var ocColorGray4 = 0xA0A0A;
var ocColorGray5 = 0xD0D0D;
var ocColorGray6 = 0xF0F0F;
var ocColorGray7 = 0x121212;
var ocColorGray8 = 0x141414;
var ocColorGray9 = 0x171717;
var ocColorGray10 = 0x1A1A1A;
var ocColorGray11 = 0x1C1C1C;
var ocColorGray12 = 0x1F1F1F;
var ocColorGray13 = 0x212121;
var ocColorGray14 = 0x242424;
var ocColorGray15 = 0x262626;
var ocColorGray16 = 0x292929;
var ocColorGray17 = 0x2B2B2B;
var ocColorGray18 = 0x2E2E2E;
var ocColorGray19 = 0x303030;
var ocColorGray20 = 0x333333;
var ocColorGray21 = 0x363636;
var ocColorGray22 = 0x383838;
var ocColorGray23 = 0x3B3B3B;
var ocColorGray24 = 0x3D3D3D;
var ocColorGray25 = 0x404040;
var ocColorGray26 = 0x424242;
var ocColorGray27 = 0x454545;
var ocColorGray28 = 0x474747;
var ocColorGray29 = 0x4A4A4A;
var ocColorGray30 = 0x4D4D4D;
var ocColorGray31 = 0x4F4F4F;
var ocColorGray32 = 0x525252;
var ocColorGray33 = 0x545454;
var ocColorGray34 = 0x575757;
var ocColorGray35 = 0x595959;
var ocColorGray36 = 0x5C5C5C;
var ocColorGray37 = 0x5E5E5E;
var ocColorGray38 = 0x616161;
var ocColorGray39 = 0x636363;
var ocColorGray40 = 0x666666;
var ocColorGray41 = 0x696969;
var ocColorGray42 = 0x6B6B6B;
var ocColorGray43 = 0x6E6E6E;
var ocColorGray44 = 0x707070;
var ocColorGray45 = 0x737373;
var ocColorGray46 = 0x757575;
var ocColorGray47 = 0x787878;
var ocColorGray48 = 0x7A7A7A;
var ocColorGray49 = 0x7D7D7D;
var ocColorGray50 = 0x7F7F7F;
var ocColorGray51 = 0x828282;
var ocColorGray52 = 0x858585;
var ocColorGray53 = 0x878787;
var ocColorGray54 = 0x8A8A8A;
var ocColorGray55 = 0x8C8C8C;
var ocColorGray56 = 0x8F8F8F;
var ocColorGray57 = 0x919191;
var ocColorGray58 = 0x949494;
var ocColorGray59 = 0x969696;
var ocColorGray60 = 0x999999;
var ocColorGray61 = 0x9C9C9C;
var ocColorGray62 = 0x9E9E9E;
var ocColorGray63 = 0xA1A1A1;
var ocColorGray64 = 0xA3A3A3;
var ocColorGray65 = 0xA6A6A6;
var ocColorGray66 = 0xA8A8A8;
var ocColorGray67 = 0xABABAB;
var ocColorGray68 = 0xADADAD;
var ocColorGray69 = 0xB0B0B0;
var ocColorGray70 = 0xB3B3B3;
var ocColorGray71 = 0xB5B5B5;
var ocColorGray72 = 0xB8B8B8;
var ocColorGray73 = 0xBABABA;
var ocColorGray74 = 0xBDBDBD;
var ocColorGray75 = 0xBFBFBF;
var ocColorGray76 = 0xC2C2C2;
var ocColorGray77 = 0xC4C4C4;
var ocColorGray78 = 0xC7C7C7;
var ocColorGray79 = 0xC9C9C9;
var ocColorGray80 = 0xCCCCCC;
var ocColorGray81 = 0xCFCFCF;
var ocColorGray82 = 0xD1D1D1;
var ocColorGray83 = 0xD4D4D4;
var ocColorGray84 = 0xD6D6D6;
var ocColorGray85 = 0xD9D9D9;
var ocColorGray86 = 0xDBDBDB;
var ocColorGray87 = 0xDEDEDE;
var ocColorGray88 = 0xE0E0E0;
var ocColorGray89 = 0xE3E3E3;
var ocColorGray90 = 0xE5E5E5;
var ocColorGray91 = 0xE8E8E8;
var ocColorGray92 = 0xEBEBEB;
var ocColorGray93 = 0xEDEDED;
var ocColorGray94 = 0xF0F0F0;
var ocColorGray95 = 0xF2F2F2;
var ocColorGray96 = 0xF5F5F5;
var ocColorGray97 = 0xF7F7F7;
var ocColorGray98 = 0xFAFAFA;
var ocColorGray99 = 0xFCFCFC;
var ocColorGreen = 0x00FF00;
var ocColorGreenYellow = 0x2FFFAD;
var ocColorHoneydew = 0xF0FFF0;
var ocColorHotPink = 0xB469FF;
var ocColorIndianRed = 0x5C5CCD;
var ocColorIvory = 0xF0FFFF;
var ocColorKhaki = 0x8CE6F0;
var ocColorLavender = 0xFAE6E6;
var ocColorLavenderBlush = 0xF5F0FF;
var ocColorLawnGreen = 0x00FC7C;
var ocColorLemonChiffon = 0xCDFAFF;
var ocColorLightBlue = 0xE6D8AD;
var ocColorLightCoral = 0x8080F0;
var ocColorLightCyan = 0xFFFFE0;
var ocColorLightGoldenrod = 0x82DDEE;
var ocColorLightGoldenrodYellow = 0xD2FAFA;
var ocColorLightGray = 0xD3D3D3;
var ocColorLightPink = 0xC1B6FF;
var ocColorLightSalmon = 0x7AA0FF;
var ocColorLightSeaGreen = 0xAAB220;
var ocColorLightSkyBlue = 0xFACE87;
var ocColorLightSlateBlue = 0xFF7084;
var ocColorLightSlateGray = 0x998877;
var ocColorLightSteelBlue = 0xDEC4B0;
var ocColorLightYellow = 0xE0FFFF;
var ocColorLimeGreen = 0x32CD32;
var ocColorLinen = 0xE6F0FA;
var ocColorMagenta = 0xFF00FF;
var ocColorMaroon = 0x6030B0;
var ocColorMediumAquamarine = 0xAACD66;
var ocColorMediumBlue = 0xCD0000;
var ocColorMediumOrchid = 0xD355BA;
var ocColorMediumPurple = 0xDB7093;
var ocColorMediumSeaGreen = 0x71B33C;
var ocColorMediumSlateBlue = 0xEE687B;
var ocColorMediumSpringGreen = 0x9AFA00;
var ocColorMediumTurquoise = 0xCCD148;
var ocColorMediumVioletRed = 0x8515C7;
var ocColorMidnightBlue = 0x701919;
var ocColorMintCream = 0xFAFFF5;
var ocColorMistyRose = 0xE1E4FF;
var ocColorMoccasin = 0xB5E4FF;
var ocColorNavajoWhite = 0xADDEFF;
var ocColorNavyBlue = 0x800000;
var ocColorOldLace = 0xE6F5FD;
var ocColorOliveDrab = 0x238E6B;
var ocColorOrange = 0x00A5FF;
var ocColorOrangeRed = 0x0045FF;
var ocColorOrchid = 0xD670DA;
var ocColorPaleGoldenrod = 0xAAE8EE;
var ocColorPaleGreen = 0x98FB98;
var ocColorPaleTurquoise = 0xEEEEAF;
var ocColorPaleVioletRed = 0x9370DB;
var ocColorPapayaWhip = 0xD5EFFF;
var ocColorPeachPuff = 0xB9DAFF;
var ocColorPeru = 0x3F85CD;
var ocColorPink = 0xCBC0FF;
var ocColorPlum = 0xDDA0DD;
var ocColorPowderBlue = 0xE6E0B0;
var ocColorPurple = 0xF020A0;
var ocColorRed = 0xFF;
var ocColorRosyBrown = 0x8F8FBC;
var ocColorRoyalBlue = 0xE16941;
var ocColorSaddleBrown = 0x13458B;
var ocColorSalmon = 0x7280FA;
var ocColorSandyBrown = 0x60A4F4;
var ocColorSeaGreen = 0x578B2E;
var ocColorSeashell = 0xEEF5FF;
var ocColorSienna = 0x2D52A0;
var ocColorSkyBlue = 0xEBCE87;
var ocColorSlateBlue = 0xCD5A6A;
var ocColorSlateGray = 0x908070;
var ocColorSnow = 0xFAFAFF;
var ocColorSpringGreen = 0x7FFF00;
var ocColorSteelBlue = 0xB48246;
var ocColorTan = 0x8CB4D2;
var ocColorThistle = 0xD8BFD8;
var ocColorTomato = 0x4763FF;
var ocColorTurquoise = 0xD0E040;
var ocColorViolet = 0xEE82EE;
var ocColorVioletRed = 0x9020D0;
var ocColorWheat = 0xB3DEF5;
var ocColorWhite = 0xFFFFFF;
var ocColorYellow = 0x00FFFF;
var ocColorYellowGreen = 0x32CD9A;

%>
