<%
'*****************************************************************************
'*
'* Copyright (c) ComponentOne LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* COMPONENTONE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. COMPONENTONE SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************

'This file contains a list of colors that can be used
' in any VB program.  These colors can also be found in
' the property pages of the Olectra Chart controls.

'The HEX values can also be broken down into their
' Red Green Blue (RGB) equivalents by breaking the number
' down by pairs of digits.  Here is an example:
'    ocColorTurquoise = &HD0E040
'    Blue = &HD0 (208), Green = &HE0 (224), Red = &H40 (64)
'
' Note that the order of RGB is from least significant to
' most significant.  i.e. &Hbbggrr
'

'ocDefaultColor is the same as "(Automatic)" in the property pages
Const ocDefaultColor = &HFFFF

Const ocColorAliceBlue = &HFFF8F0
Const ocColorAntiqueWhite = &HD7EBFA
Const ocColorAquamarine = &HD4FF7F
Const ocColorAzure = &HFFFFF0
Const ocColorBeige = &HDCF5F5
Const ocColorBisque = &HC4E4FF
Const ocColorBlack = &H0
Const ocColorBlanchedAlmond = &HCDEBFF
Const ocColorBlue = &HFF0000
Const ocColorBlueViolet = &HE22B8A
Const ocColorBrown = &H2A2AA5
Const ocColorBurlywood = &H87B8DE
Const ocColorCadetBlue = &HA09E5F

'ocColorChartreuse = &H00FF7F
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorChartreuse = 65407

Const ocColorChocolate = &H1E69D2
Const ocColorCoral = &H507FFF
Const ocColorCornflowerBlue = &HED9564
Const ocColorCornsilk = &HDCF8FF
Const ocColorCyan = &HFFFF00
Const ocColorDarkGoldenrod = &HB86B8

'ocColorDarkGreen = &H006400
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorDarkGreen = 25600

Const ocColorDarkKhaki = &H6BB7BD
Const ocColorDarkOliveGreen = &H2F6B55
Const ocColorDarkOrange = &H8CFF
Const ocColorDarkOrchid = &HCC3299
Const ocColorDarkSalmon = &H7A96E9
Const ocColorDarkSeaGreen = &H8FBC8F
Const ocColorDarkSlateBlue = &H8B3D48
Const ocColorDarkSlateGray = &H4F4F2F
Const ocColorDarkTurquoise = &HD1CE00
Const ocColorDarkViolet = &HD30094
Const ocColorDeepPink = &H9314FF
Const ocColorDeepSkyBlue = &HFFBF00
Const ocColorDodgerBlue = &HFF901E
Const ocColorFirebrick = &H2222B2
Const ocColorFloralWhite = &HF0FAFF
Const ocColorForestGreen = &H228B22
Const ocColorGainsboro = &HDCDCDC
Const ocColorGhostWhite = &HFFF8F8

'ocColorGold = &H00D7FF
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorGold = 55295

Const ocColorGoldenrod = &H20A5DA
Const ocColorGray = &HBEBEBE
Const ocColorGray0 = &H0
Const ocColorGray1 = &H30303
Const ocColorGray2 = &H50505
Const ocColorGray3 = &H80808
Const ocColorGray4 = &HA0A0A
Const ocColorGray5 = &HD0D0D
Const ocColorGray6 = &HF0F0F
Const ocColorGray7 = &H121212
Const ocColorGray8 = &H141414
Const ocColorGray9 = &H171717
Const ocColorGray10 = &H1A1A1A
Const ocColorGray11 = &H1C1C1C
Const ocColorGray12 = &H1F1F1F
Const ocColorGray13 = &H212121
Const ocColorGray14 = &H242424
Const ocColorGray15 = &H262626
Const ocColorGray16 = &H292929
Const ocColorGray17 = &H2B2B2B
Const ocColorGray18 = &H2E2E2E
Const ocColorGray19 = &H303030
Const ocColorGray20 = &H333333
Const ocColorGray21 = &H363636
Const ocColorGray22 = &H383838
Const ocColorGray23 = &H3B3B3B
Const ocColorGray24 = &H3D3D3D
Const ocColorGray25 = &H404040
Const ocColorGray26 = &H424242
Const ocColorGray27 = &H454545
Const ocColorGray28 = &H474747
Const ocColorGray29 = &H4A4A4A
Const ocColorGray30 = &H4D4D4D
Const ocColorGray31 = &H4F4F4F
Const ocColorGray32 = &H525252
Const ocColorGray33 = &H545454
Const ocColorGray34 = &H575757
Const ocColorGray35 = &H595959
Const ocColorGray36 = &H5C5C5C
Const ocColorGray37 = &H5E5E5E
Const ocColorGray38 = &H616161
Const ocColorGray39 = &H636363
Const ocColorGray40 = &H666666
Const ocColorGray41 = &H696969
Const ocColorGray42 = &H6B6B6B
Const ocColorGray43 = &H6E6E6E
Const ocColorGray44 = &H707070
Const ocColorGray45 = &H737373
Const ocColorGray46 = &H757575
Const ocColorGray47 = &H787878
Const ocColorGray48 = &H7A7A7A
Const ocColorGray49 = &H7D7D7D
Const ocColorGray50 = &H7F7F7F
Const ocColorGray51 = &H828282
Const ocColorGray52 = &H858585
Const ocColorGray53 = &H878787
Const ocColorGray54 = &H8A8A8A
Const ocColorGray55 = &H8C8C8C
Const ocColorGray56 = &H8F8F8F
Const ocColorGray57 = &H919191
Const ocColorGray58 = &H949494
Const ocColorGray59 = &H969696
Const ocColorGray60 = &H999999
Const ocColorGray61 = &H9C9C9C
Const ocColorGray62 = &H9E9E9E
Const ocColorGray63 = &HA1A1A1
Const ocColorGray64 = &HA3A3A3
Const ocColorGray65 = &HA6A6A6
Const ocColorGray66 = &HA8A8A8
Const ocColorGray67 = &HABABAB
Const ocColorGray68 = &HADADAD
Const ocColorGray69 = &HB0B0B0
Const ocColorGray70 = &HB3B3B3
Const ocColorGray71 = &HB5B5B5
Const ocColorGray72 = &HB8B8B8
Const ocColorGray73 = &HBABABA
Const ocColorGray74 = &HBDBDBD
Const ocColorGray75 = &HBFBFBF
Const ocColorGray76 = &HC2C2C2
Const ocColorGray77 = &HC4C4C4
Const ocColorGray78 = &HC7C7C7
Const ocColorGray79 = &HC9C9C9
Const ocColorGray80 = &HCCCCCC
Const ocColorGray81 = &HCFCFCF
Const ocColorGray82 = &HD1D1D1
Const ocColorGray83 = &HD4D4D4
Const ocColorGray84 = &HD6D6D6
Const ocColorGray85 = &HD9D9D9
Const ocColorGray86 = &HDBDBDB
Const ocColorGray87 = &HDEDEDE
Const ocColorGray88 = &HE0E0E0
Const ocColorGray89 = &HE3E3E3
Const ocColorGray90 = &HE5E5E5
Const ocColorGray91 = &HE8E8E8
Const ocColorGray92 = &HEBEBEB
Const ocColorGray93 = &HEDEDED
Const ocColorGray94 = &HF0F0F0
Const ocColorGray95 = &HF2F2F2
Const ocColorGray96 = &HF5F5F5
Const ocColorGray97 = &HF7F7F7
Const ocColorGray98 = &HFAFAFA
Const ocColorGray99 = &HFCFCFC

'ocColorGreen = &H00FF00
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorGreen = 65280

Const ocColorGreenYellow = &H2FFFAD
Const ocColorHoneydew = &HF0FFF0
Const ocColorHotPink = &HB469FF
Const ocColorIndianRed = &H5C5CCD
Const ocColorIvory = &HF0FFFF
Const ocColorKhaki = &H8CE6F0
Const ocColorLavender = &HFAE6E6
Const ocColorLavenderBlush = &HF5F0FF

'ocColorLawnGreen = &H00FC7C
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorLawnGreen = 64636

Const ocColorLemonChiffon = &HCDFAFF
Const ocColorLightBlue = &HE6D8AD
Const ocColorLightCoral = &H8080F0
Const ocColorLightCyan = &HFFFFE0
Const ocColorLightGoldenrod = &H82DDEE
Const ocColorLightGoldenrodYellow = &HD2FAFA
Const ocColorLightGray = &HD3D3D3
Const ocColorLightPink = &HC1B6FF
Const ocColorLightSalmon = &H7AA0FF
Const ocColorLightSeaGreen = &HAAB220
Const ocColorLightSkyBlue = &HFACE87
Const ocColorLightSlateBlue = &HFF7084
Const ocColorLightSlateGray = &H998877
Const ocColorLightSteelBlue = &HDEC4B0
Const ocColorLightYellow = &HE0FFFF
Const ocColorLimeGreen = &H32CD32
Const ocColorLinen = &HE6F0FA
Const ocColorMagenta = &HFF00FF
Const ocColorMaroon = &H6030B0
Const ocColorMediumAquamarine = &HAACD66
Const ocColorMediumBlue = &HCD0000
Const ocColorMediumOrchid = &HD355BA
Const ocColorMediumPurple = &HDB7093
Const ocColorMediumSeaGreen = &H71B33C
Const ocColorMediumSlateBlue = &HEE687B
Const ocColorMediumSpringGreen = &H9AFA00
Const ocColorMediumTurquoise = &HCCD148
Const ocColorMediumVioletRed = &H8515C7
Const ocColorMidnightBlue = &H701919
Const ocColorMintCream = &HFAFFF5
Const ocColorMistyRose = &HE1E4FF
Const ocColorMoccasin = &HB5E4FF
Const ocColorNavajoWhite = &HADDEFF
Const ocColorNavyBlue = &H800000
Const ocColorOldLace = &HE6F5FD
Const ocColorOliveDrab = &H238E6B

'ocColorOrange = &H00A5FF
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorOrange = 42495

'ocColorOrangeRed = &H0045FF
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorOrangeRed = 17919

Const ocColorOrchid = &HD670DA
Const ocColorPaleGoldenrod = &HAAE8EE
Const ocColorPaleGreen = &H98FB98
Const ocColorPaleTurquoise = &HEEEEAF
Const ocColorPaleVioletRed = &H9370DB
Const ocColorPapayaWhip = &HD5EFFF
Const ocColorPeachPuff = &HB9DAFF
Const ocColorPeru = &H3F85CD
Const ocColorPink = &HCBC0FF
Const ocColorPlum = &HDDA0DD
Const ocColorPowderBlue = &HE6E0B0
Const ocColorPurple = &HF020A0
Const ocColorRed = &HFF
Const ocColorRosyBrown = &H8F8FBC
Const ocColorRoyalBlue = &HE16941
Const ocColorSaddleBrown = &H13458B
Const ocColorSalmon = &H7280FA
Const ocColorSandyBrown = &H60A4F4
Const ocColorSeaGreen = &H578B2E
Const ocColorSeashell = &HEEF5FF
Const ocColorSienna = &H2D52A0
Const ocColorSkyBlue = &HEBCE87
Const ocColorSlateBlue = &HCD5A6A
Const ocColorSlateGray = &H908070
Const ocColorSnow = &HFAFAFF
Const ocColorSpringGreen = &H7FFF00
Const ocColorSteelBlue = &HB48246
Const ocColorTan = &H8CB4D2
Const ocColorThistle = &HD8BFD8
Const ocColorTomato = &H4763FF
Const ocColorTurquoise = &HD0E040
Const ocColorViolet = &HEE82EE
Const ocColorVioletRed = &H9020D0
Const ocColorWheat = &HB3DEF5
Const ocColorWhite = &HFFFFFF

'ocColorYellow = &H00FFFF
'The above would be true, but Visual Basic removes the leading zeros
Const ocColorYellow = 65535

Const ocColorYellowGreen = &H32CD9A

%>
