<%
'*****************************************************************************
'*
'* Copyright (c) ComponentOne LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* COMPONENTONE MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. COMPONENTONE SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************


'---- ErrorConstants Values ----          Specifies the error detected by the chart.
Const ocErrorInvalidIndex = 0           ' Invalid index found in variant
Const ocErrorReadOnly = 1               ' Property is read-only and cannot be modified
Const ocErrorOutOfRange = 2             ' Numeric value is out of range
Const ocErrorInvalidEnum = 3            ' Invalid enumerated value for property
Const ocErrorInvalidValue = 4           ' Invalid value for property
Const ocErrorNoSuchProperty = 5         ' Property does not exist for this instance of the object
Const ocErrorDuplicateValue = 6         ' Collection already contains a duplicate value
Const ocErrorNoSuchItem = 7             ' Cannot find item in collection
Const ocErrorCannotCreateObject = 8     ' Cannot create object
Const ocErrorTypeMismatch = 9           ' Property set to wrong object type
Const ocErrorReadOnlyWhenBound = 10     ' Property is read-only when the chart group is bound
Const ocErrorBadArrayDimensions = 11    ' Wrong dimensions in SafeArray passed to a function
Const ocErrorNotConnected = 12          ' Object does not have a parent
Const ocErrorInvalidFormat = 13         ' Invalid custom format
Const ocErrorDllNotCompatible = 14      ' DLL version is not compatible
Const ocErrorSeriesArrayNotOne = 15     ' Series index must be 1 for Array data layout
%>
