<%
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************

Sub DemoPageHeader()
  '
  ' Generates a header for a WebChart demo ASP page.  The header
  ' contains images and links back to the WebChart Demo Home Page
  ' and the ComponentOne website
  '
  With Response
    .Write("<table border=0 align=center width=100% ><tbody><font face=Tahoma>")
    .Write("<tr><td valign=center><p align=left>")
    .Write("<a href=""/WebChart8/default.asp"">")
    .Write("<img src=""/WebChart8/c1chart8_sm.gif"" alt=""WebChart Demos Home Page"" border=0>")
    .Write("</a></p></td><td valign=center><p align=right>")
    .Write("<a href=""http://www.componentone.com"">")
    .Write("<img src=""/WebChart8/logo_c1.gif"" alt=""http://www.componentone.com"" border=0>")
    .Write("</a></p></td></tr></font></tbody></table>")
  End With
End Sub

Sub DemoSeparator()
  ' Generates a horizontal rule separator
  Response.Write("<hr width=90% align=center size=5><br>")
End Sub

Sub DemoTitle(ndim, titleString)
  '
  ' Generates consistent titles and subtitles for WebChart Demos
  '
  With Response
    .Write("<font color=#d70000 face=Arial>")
	  .Write("<p align=center><big><big><big><strong>")
	    .Write("ComponentOne WebChart " + ndim)
      .Write("</strong></big></big></big></p>")

      .Write("<p align=center><big><big>")
	    .Write(titleString)
      .Write("</big></big></p>")
	.Write("</font>")
  End With
  Call DemoSeparator()
End Sub

Sub DemoTitle2D(titleString)
  Call DemoTitle("2D",titleString)
End Sub

Sub DemoTitle3D(titleString)
  Call DemoTitle("3D",titleString)
End Sub

Sub DemoCopyrightAndSource()
  '
  ' Generates a table with Copyright and View Source
  ' entries for a demo WebChart ASP page
  '
  With Response
    .Write("<table align=center valign=center width=90% ><tbody><tr>")
    .Write("<font size = -2 face=Arial>")
    .Write("<td align=left><a href=""/WebChart8/copyright.htm"">Copyright</a> ComponentOne LLC</td>")
    .Write("<td align=right><a target=_blank href=""/WebChart8/srcview.asp?fn=" + Request.ServerVariables("URL") + "&stype=vbs"">View Source</a></td>")
    .Write("</font></tr></tbody></table>")
  End With
End Sub

Sub DemoInitFont(aXrtFont,size,isBold)
  aXrtFont.Bold = isBold
  aXrtFont.Italic = False
  aXrtFont.Underline = False
  aXrtFont.Strikethrough = False
  aXrtFont.Name = "Arial"
  aXrtFont.Size = size
  If isBold Then
    aXrtFont.Weight = 700
  Else
    aXrtFont.Weight = 400
  End If
  aXrtFont.Charset = 0
End Sub

Sub DemoCheckWriter(isChecked)
  If isChecked Then
    Response.Write(" CHECKED ")
  End If
End Sub

%>

