<%@ Language=VBScript %>
<!---
'*****************************************************************************
'*
'* Copyright (c) ComponentOne, LLC.
'* Portions Copyright (c) 1999, KL GROUP INC.
'* http://www.componentone.com
'*
'* This file is provided for demonstration and educational uses only.
'* Permission to use, copy, modify and distribute this file for
'* any purpose and without fee is hereby granted, provided that the
'* above copyright notice and this permission notice appear in all
'* copies, and that the name of ComponentOne not be used in advertising
'* or publicity pertaining to this material without the specific,
'* prior written permission of an authorized representative of
'* ComponentOne.
'*
'* ComponentOne MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY
'* OF THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
'* TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
'* PURPOSE, OR NON-INFRINGEMENT. ComponentOne SHALL NOT BE LIABLE FOR ANY
'* DAMAGES SUFFERED BY USERS AS A RESULT OF USING, MODIFYING OR
'* DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
'*
'*****************************************************************************
-->

<%
  Function getSourceFilename()
    If Request.QueryString("fn").Count > 0 Then
      getSourceFilename = Request.QueryString("fn")(1)
    Else
      getSourceFilename = ""
    End If
  End Function

  Sub buildIncLink(incName)
    Dim s
    If Request.QueryString("stype").Count > 0 Then
      s = Request.QueryString("stype")(1)
    Else
      s = "vbs"
    End If
    s = Request.ServerVariables("URL") + "?fn=Include/" + s + "/" + incName + "&stype=" + s
    Response.Write("<a target=_blank href=""" + s + """>" + incName + "</a>")
  End Sub
%>

<html>
  <head>
    <title><% Response.Write(getSourceFilename()) %> Source</title>
  </head>
  <body bgcolor=#E8E8E8>
    <hr align=center width=100% color=green size=3 noshade></hr>
    <p align=left>
      <font face="Tahoma" color=green size=4>
        <% Response.Write(getSourceFilename()) %>
      </font>
    </p>

    <%
      Dim fso, f, sc, sa, sm
      Set fso = CreateObject("Scripting.FileSystemObject")
      Set f = fso.GetFile(Server.MapPath(getSourceFilename()))
      sc = f.DateCreated
      sa = f.DateLastAccessed
      sm = f.DateLastModified 
    %>

    <table border=0 align=center width=100% style="float:none">
      <tr align=center><td>
        <table align=left border=0 cellpadding=4 width=100% style="font: 9pt tahoma; color=green; float:none">
          <tr>
            <td>Created: <%= sc %></td>
            <td>LastModified: <%= sm %></td>
            <td>Last Accessed: <%= sa %></td>
          </tr>
        </table>
      </td></tr>
      <tr align=center><td>
        <table align=center border=1 cellpadding=8 width=100% style="font: 9pt tahoma; float:none">
          <tr align=center>
            <td><% buildIncLink("color.inc") %></td>
            <td><% buildIncLink("2dconst.inc") %></td>
            <td><% buildIncLink("3dconst.inc") %></td>
          </tr>
          <tr align=center>
            <td><% buildIncLink("utils.inc") %></td>
            <td><% buildIncLink("2dgentag.inc") %></td>
            <td><% buildIncLink("3dgentag.inc") %></td>
          </tr>
          <tr align=center>
            <td><% buildIncLink("error.inc") %></td>
            <td><% buildIncLink("showimage.asp") %></td>
            <td>&nbsp;</td>
          </tr>
        </table>
      </td></tr>
    </table>
    <br>
    <a target=_blank href="hlpview.htm" style="font: 9pt tahoma">Source Viewer Help</a><br>
    <hr align=center width=100% color=green size=3 noshade></hr>

    <%
      Sub outputString(oStr, smode)
        Dim s, t, ista, iend
        s = Server.HTMLEncode(oStr)

        If smode = 0 Then
          ista = 1
          Do Until ista > Len(s)
            iend = InStr(ista, s, "&")
            If iend >= ista Then
              t = Mid(s, iend, 4)
              If t = "&lt;" Or t = "&gt;" Then
                Response.Write(Mid(s,ista,iend-ista))
                Response.Write("<font color=navy>" + t + "</font>")
                ista = iend + Len(t)
              Else
                Response.Write(Mid(s, ista, iend - ista + 1))
                ista = iend + 1
              End If
            Else
              Response.Write(Mid(s,ista))
              ista = Len(s) + 1
            End If
          Loop
        Else
          Response.Write(s)
        End If
      End Sub

      sa=""
      sc=""
      sm=""

      Set f = fso.OpenTextFile(Server.MapPath(getSourceFilename()),1,-1)
      sa = f.ReadAll
      f.Close

      Dim smode, ista, iend, sOn, sOff, sOn2, sOff2
      Const xHtml = "<font color=green>"
      Const xTran = "<font color=red>"
      Const xScript = "<font color=black>"
      Const xOff = "</font>"

      sOn = "<" + "%"
      sOff = "%" + ">"
      sOn2 = "&lt;%"
      sOff2 = "%&gt;"
      smode = 0   '0=html, 1=script


      Response.Write("<br><pre>")

      '
      ' handle the first characters, then
      ' fall into the loop to handle the rest
      '
      If Left(sa,2) = sOn Then
        Response.Write( xTran + sOn2 + xOff + xScript)
        ista=1+Len(sOn)
        smode = 1
      Else
        Response.Write(xHtml)
        ista=1
        smode = 0
      End If

      Do Until ista > Len(sa)

        If smode = 0 Then
          sc = sOn
          sm = sOn2
        Else
          sc = sOff
          sm = sOff2
        End If
        iend = InStr(ista, sa, sc)

        If iend >= ista Then
          
          If iend > ista Then
            Call outputString(Mid(sa, ista, iend - ista), smode)
          End If
          Response.Write(xOff + xTran + sm + xOff)

          If smode = 0 Then
            ' switch to script mode
            smode = 1
            Response.Write(xScript)
          Else
            ' switch to html mode
            smode = 0
            Response.Write(xHtml)
          End If

          ' adjust the start position
          ista = iend + Len(sc)

        Else
          ' no more text. dump what's left and close the tag
          Call outputString(Mid(sa, ista), smode)
          Response.Write(xOff)
          ista = Len(sa) + 1
        End If

      Loop
      Response.Write("</pre><br>")

      sa=""
    %>
  </body
</html>
